#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; }
const int MAXN = (1 << 20);

int read_int();

int n, m, k;
pair<int, pair<int, int> > li[MAXN];
vector<int> adj[MAXN];

void read()
{
	n = read_int();
	m = read_int();
	k = read_int();
	for(int i = 1; i <= m; i++)
	{
		int u, v, w;
		u = read_int();
		v = read_int();
		w = read_int();
		li[i] = make_pair(w, make_pair(u, v));
	}
}

vector<int> answer;

int low[MAXN], disc[MAXN];
int dfs_time;

void tarjan(int u, int pr)
{
	low[u] = disc[u] = ++dfs_time;
	int children = 0;

	bool is_ap = 0;
	for(int v: adj[u])
		if(disc[v] == -1)
		{
			children++;
			tarjan(v, u);
			chkmin(low[u], low[v]);

			if(pr != -1 && disc[u] <= low[v]) is_ap = 1;
		}
		else if(v != pr)
			chkmin(low[u], disc[v]);

	if((pr == -1 && children >= 2) || is_ap)
		answer.push_back(u);
}

bool check(int L, int err = 0)
{
	answer.clear();
	if(L == -1)
		return true;

	for(int i = 1; i <= n; i++) adj[i].clear();
	for(int i = 1; i <= m; i++)
		if(li[i].first > li[L].first)
		{
			adj[li[i].second.first].push_back(li[i].second.second);
			adj[li[i].second.second].push_back(li[i].second.first);
		}

	for(int i = 1; i <= n; i++) disc[i] = low[i] = -1;

	dfs_time = 0;
	for(int i = 1; i <= n; i++)
		if(disc[i] == -1)
            tarjan(i, -1);

	return (int)answer.size() >= k - err;
}

void solve()
{
	sort(li + 1, li + m + 1);
	int low = 0, high = m, mid, ret = -1;

	while(low - high >= 500)
	{
        int mid = (low + high) >> 1;
        if(check(mid, 0))
            high = mid - 1;
        else
            low = mid + 1;
	}

    for(int i = low; i <= high; i++)
        if(check(i))
        {
            ret = i;
            return;
        }

	check(ret);

	sort(answer.begin(), answer.end());
	cout << ((ret != -1) ? li[ret].first : -1) << " " << answer.size() << endl;
	for(int x: answer) cout << x << " ";
	cout << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}

char buff[MAXN];
int pos_buff;

void next_char() { if(++pos_buff == MAXN) fread(buff, 1, MAXN, stdin), pos_buff = 0;}

int read_int()
{
    int ret = 0;
    for(; buff[pos_buff] > '9' || buff[pos_buff] < '0'; next_char());
    for(; buff[pos_buff] <= '9' && buff[pos_buff] >= '0'; next_char())
        ret = ret * 10 + buff[pos_buff] - '0';

    return ret;
}
