#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; }
const int MAXN = (1 << 20);

typedef vector<int> numb;
int base;

numb add(numb a, numb b)
{
    numb ret;

    int carry = 0, i = a.size() - 1, j = b.size() - 1;
    while(i >= 0 && j >= 0)
    {
        int d = a[i] + b[j] + carry;
        ret.push_back(d % base);
        carry = d / base;
        i--, j--;
    }

    while(i >= 0)
    {
        int d = a[i] + carry;
        ret.push_back(d % base);
        carry = d / base;
        i--;
    }

    while(j >= 0)
    {
        int d = b[j] + carry;
        ret.push_back(d % base);
        carry = d / base;
        j--;
    }

    while(carry)
    {
        ret.push_back(carry % base);
        carry /= base;
    }

    reverse(ret.begin(), ret.end());
    return ret;
}

numb sub(numb a, numb b)
{
    numb ret;

    int carry = 0, i = a.size() - 1, j = b.size() - 1;
    while(i >= 0 && j >= 0)
    {
        int d = a[i] - b[j] - carry;
        carry = 0;
        while(d < 0) carry++, d += base;
        ret.push_back(d % base);
        i--, j--;
    }

    while(i >= 0)
    {
        int d = a[i] - carry;
        carry = 0;
        while(d < 0) carry++, d += base;
        ret.push_back(d % base);
        i--;
    }

	while(ret.size() > 1 && ret.back() == 0) ret.pop_back();
    reverse(ret.begin(), ret.end());
    return ret;
}

numb mult(numb a, numb b)
{
    numb ret((1 + a.size() + b.size()) * 2);
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());
    
    for(int i = 0; i < a.size(); i++)
    	for(int j = 0; j < b.size(); j++)
			ret[i + j] += a[i] * b[j];
			
	int carry = 0;
	for(int i = 0; i < ret.size(); i++)
	{
		int d = ret[i] + carry;
		ret[i] = d % base;
		carry = d / base;
	}
	
	while(ret.size() > 1 && ret.back() == 0) ret.pop_back();
	reverse(ret.begin(), ret.end());
	return ret;
}

string A, B;

int to_dig(char c)
{
	if(c >= 'A' && c <= 'Z') return 10 + c - 'A';
	return c - '0';
}

char to_char(int d)
{
	if(d >= 10) return d - 10 + 'A';
	return d + '0';
}

void read()
{
	cin >> base;
	cin >> A >> B;
}

pair<numb, numb> dv(numb a, numb b)
{
	numb curr;
	pair<numb, numb> ret;
	for(int i = 0; i < a.size(); i++)
	{
		curr.push_back(a[i]);
		ret.first.push_back(0);
		while(curr.size() > b.size()) ret.first[ret.first.size() - 1]++, curr = sub(curr, b);
		while(curr.size() == b.size() && curr >= b) ret.first[ret.first.size() - 1]++, curr = sub(curr, b);
		if(curr.size() == 1 && curr.back() == 0) curr.pop_back();
		if(ret.first.size() == 1 && ret.first.back() == 0) ret.first.pop_back();
	}
	
	if(ret.first.empty()) ret.first.push_back(0);
	ret.second = curr;
	return ret;
}

void solve()
{
	numb A1, A2, Ap, B1, B2, Bp;
	
	int fl = 0;
	for(int i = 0; i < A.size(); i++)
	{
		if(A[i] == '(' || A[i] == ')' || A[i] == '.')
		{
			fl++;
			continue;
		}
		
		if(fl == 0) A1.push_back(to_dig(A[i]));
		if(fl == 1) A2.push_back(to_dig(A[i]));
		if(fl == 2) Ap.push_back(to_dig(A[i]));
	}
	
	fl = 0;
	
	for(int i = 0; i < B.size(); i++)
	{
		if(B[i] == '(' || B[i] == ')' || B[i] == '.')
		{
			fl++;
			continue;
		}
		
		if(fl == 0) B1.push_back(to_dig(B[i]));
		if(fl == 1) B2.push_back(to_dig(B[i]));
		if(fl == 2) Bp.push_back(to_dig(B[i]));
	}

	if(B2.empty()) B2.push_back(0);
	if(B1.empty()) B1.push_back(0);
	if(Bp.empty()) Bp.push_back(0);
		
	if(A2.empty()) A2.push_back(0);
	if(A1.empty()) A1.push_back(0);
	if(Ap.empty()) Ap.push_back(0);

	pair<numb, numb> f, s;
	
	numb down1, down2;
	for(int i = 0; i < Ap.size(); i++) down1.push_back(base - 1);
	for(int i = 0; i < Bp.size(); i++) down2.push_back(base - 1);

	f.second = down1; for(int i = 0; i < A2.size(); i++) f.second.push_back(0);
	s.second = down2; for(int i = 0; i < B2.size(); i++) s.second.push_back(0);

	f.first = add(mult(A1, f.second), add(mult(A2, down1), Ap));
	s.first = add(mult(B1, s.second), add(mult(B2, down2), Bp));

	pair<numb, numb> ret;
	ret.first = add(mult(f.first, s.second), mult(f.second, s.first));
	ret.second = mult(f.second, s.second);

	/*for(int i = 0; i < ret.first.size(); i++) cout << to_char(ret.first[i]);
	cout << "  /  ";
	for(int i = 0; i < ret.second.size(); i++) cout << to_char(ret.second[i]);
	cout << endl;*/
	
	ret = dv(ret.first, ret.second);

	
	for(int i = 0; i < ret.first.size(); i++) cout << to_char(ret.first[i]);
	/*cout << "  .  ";
	for(int i = 0; i < ret.second.size(); i++) cout << to_char(ret.second[i]);*/
	cout << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}
