#include <cstdio>
#include <iostream>
#include <sstream>
#include <iomanip>
#include <cmath>
#include <algorithm>
using namespace std;
using ldouble = long double;

int p;
string a, b;

int get_digit(char c)
{
    if(c>='0' && c<='9')return c-'0';
    if(c>='a' && c<='z')return c-'a';
    if(c>='A' && c<='Z')return c-'A';
    return 0;
}

char give_digit(int index)
{
    if(index<10)return '0'+index;
    else return 'A'+index-10;
}

ldouble convert(const string &s)
{
    ldouble result = 0;
    bool dotted = false;
    ldouble ld = 5;

    int periodStart = -1;
    int periodLen;

    for(int i=0, afterPeriod = 0;i<512;i++)
    {
        if(s[i]=='.')dotted = true;
        else if(s[i]=='(')
        {
            if(periodStart==-1)
            {
                periodStart = i+1;
                periodLen = s.size() -i -2;
                //printf("perLen: %d\n", periodLen);
            }
        }
        else
        {
            char digChar = '_';
            if(i<s.size() && s[i]!=')')digChar = s[i];
            else
            {
                digChar = s[periodStart + afterPeriod%periodLen];
            }

            //printf("%c ", digChar);

            if(!dotted)result = result * p + get_digit(digChar);
            else
            {
                result += get_digit(digChar)/ld;
                ld*=p;
            }

            if(periodStart!=-1)afterPeriod++;
        }
    }

    return result;
}

string to_string(ldouble value, int precision)
{
    stringstream stream;
    stream<<setprecision(precision)<<value;
    return stream.str();
}

string convert(ldouble value)
{
    stringstream result;

    int iVal = (int)value;

    do
    {
        result<<give_digit(iVal%p);
        iVal/=p;
    }while(iVal!=0);

    string s = result.str();
    reverse(s.begin(), s.end());
    return s;
}

void solve()
{
    //cout<<convert(a)<<endl;
    //cout<<convert(b)<<endl;
    double result = convert(a) + convert(b);
    cout<<convert(result)<<endl;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>p>>a>>b;
    solve();
}
/**
5
1242.122(2)
002.322(22)
**/
