#include <iostream>
#include <cmath>
#include <set>
#include <vector>
#include <tuple>
#include <climits>
using namespace std;
#ifndef EVAL
void play(int n, int m, const vector<vector<char> > &table);

static int n__, m__;
static char t__[128][128];
static bool hasSkipped__ = false;
static int hunteri__ = -1, hunterj__ = -1;

static bool ontable__(int i, int j){
    return i>=0 && i<n__ && j>=0 && j<m__ && t__[i][j]=='.';
}

static bool mov__(int i, int j){
    if (i==-1 && j==-1 && !hasSkipped__ && hunteri__ == -1 && hunterj__ == -1) {
        hasSkipped__ = 1;
        return true;
    }
    if (hunteri__ == -1 && hunterj__ == -1 && ontable__(i, j)){
        hunteri__ = i;
        hunterj__ = j;
        t__[i][j] = '#';
        return true;
    }
    if (hunteri__!=-1 && ontable__(i, j)){
        if (hunteri__ == i && abs(hunterj__ - j) == 1){
            hunteri__ = i;
            hunterj__ = j;
            t__[i][j] = '#';
            return true;
        }
        if (hunterj__ == j && abs(hunteri__ - i) == 1){
            hunteri__ = i;
            hunterj__ = j;
            t__[i][j] = '#';
            return true;
        }
    }
    return false;
}

void printTableState(){
    cout<<"Current table:\n";
    for (int i=0; i<n__; ++i){
        for (int j=0; j<m__; ++j){
            if (i==hunteri__ && j==hunterj__){
                cout<<"*";
            }else{
                cout<<t__[i][j];
            }
        }
        cout<<endl;
    }
}

pair<int, int> makeMove(int i, int j){
    cout<<"move to ("<<i<<", "<<j<<")\n";
    if (!mov__(i, j)){
        cout<<"Your code made an invalid move.\n";
        return make_pair(-1, -1);
    }
    if (!ontable__(hunteri__-1, hunterj__) && !ontable__(hunteri__+1, hunterj__) && !ontable__(hunteri__, hunterj__-1) && !ontable__(hunteri__, hunterj__+1)){
        cout<<"You can't make a valid move so your code wins.\n";
        return make_pair(-1, -1);
    }
    printTableState();
    int posi, posj;
    cout<<"Enter coordinates of your move:\n";
    cin>>posi>>posj;
    while(!mov__(posi, posj)){
        cout<<"Your move was invalid... Try again:\n";
        cin>>posi>>posj;
    }
    return make_pair(posi, posj);
}

int main(){
    cin>>n__>>m__;
    for (int i=0; i<n__; ++i){
        cin>>t__[i];
    }
    vector<vector<char> > table;
    table.resize(n__);
    for (int i=0; i<n__; ++i){
        table[i].resize(m__);
        for (int j=0; j<m__; ++j){
            table[i][j] = t__[i][j];
        }
    }
    play(n__, m__, table);
    return 0;
}
#else
#include "hunter.h"
#endif // EVAL

struct point
{
    int x, y;
    point():point(0, 0){}
    point(const pair<int, int> &p):point(p.first, p.second){}
    point(int x, int y):x(x), y(y){}
    operator pair<int, int>(){return {x, y};}

    point up(){return {x-1, y};}
    point down(){return {x+1, y};}
    point left(){return {x, y-1};}
    point right(){return {x, y+1};}

    bool RiP ()const{return x==-1 && y==-1;}

    bool operator < (const point &x) const
    {
        return tie(this->x, this->y) < tie(x.x, x.y);
    }
};

int n, m;
vector<vector<char>> table;

bool can_move(point to)
{
    int x = to.x, y=to.y;
    if(x<0 || y<0 || x>=n || y>=m)return false;
    if(table[x][y]=='#')return false;

    return true;
}

int64_t rate(point pos, int depth=1, int q = 1)
{
    ///q is 1 if we play
    ///q is -1 if they play
    if(!can_move(pos))
    {
        if(q==1)return -999999;
        else return +999999;
    }

    int x = pos.x, y=pos.y;

    int64_t value = 0;
    if(depth == 5)
    {
        if(can_move(pos.up()))value+=3*q;
        if(can_move(pos.down()))value+=3*q;
        if(can_move(pos.left()))value+=3*q;
        if(can_move(pos.right()))value+=3*q;
        return value;
    }
    else
    {
        table[x][y]='#';

        if(can_move(pos.up()))
        {
            value+=rate(pos.up(), depth+1, -q);
        }
        else value-=q;

        if(can_move(pos.down()))
        {
            value+=rate(pos.down(), depth+1, -q);
        }
        else value-=q;

        if(can_move(pos.left()))
        {
            value+=rate(pos.left(), depth+1, -q);
        }
        else value-=q;

        if(can_move(pos.right()))
        {
            value+=rate(pos.right(), depth+1, -q);
        }
        else value-=q;

        table[x][y]='.';
    }
}

void go(point position);

void play(int n, int m, const vector<vector<char> > &table)
{
    ::n=n;
    ::m=m;
    ::table = table;

    int maxRate = -1;
    point maxRatePos;

    for(int i=0;i<n;i++)
    {
        for(int j=0;j<m;j++)
        {
            int ijRate = rate({i, j});
            if(ijRate > maxRate)
            {
                maxRate = ijRate;
                maxRatePos = {i, j};
            }
            #ifndef EVAL
            printf("%d ", ijRate);
            #endif
        }
        #ifndef EVAL
        putchar('\n');
        #endif // EVAL
    }

    printf("max rate: %d   at: (%d, %d)", maxRate, maxRatePos);

    if(maxRate == -1)go({-1, -1});///fuck 'em up fam!
    else go(maxRatePos);
}

void go(point pos)
{
    vector<pair<point, int64_t>> rates(4);
    for(;;)
    {
        if(!pos.RiP())table[pos.x][pos.y] = '#';
        pos = makeMove(pos.x, pos.y);
        if(pos.RiP())return;

        rates[0] = {pos.up(), rate(pos.up())};
        rates[1] = {pos.down(), rate(pos.down())};
        rates[2] = {pos.left(), rate(pos.left())};
        rates[3] = {pos.right(), rate(pos.right())};

        #ifndef EVAL
        printf("   we're at: (%d %d)\n", pos);
        printf("   rates are:\n");
        for(auto &x : rates)
        {
            printf("   (%d %d) : %lld\n", x.first, x.second);
        }
        putchar('\n');
        #endif // EVAL

        int bestRateI = 0;
        for(int i=1;i<4;i++)
        {
            if(rates[i].second > rates[bestRateI].second)bestRateI=i;
        }

        pos = rates[bestRateI].first;
    }
}
/**
5 5
.....
#..##
.....
##..#
.....
**/
