#include <cstdio>
#include <iostream>
#include <sstream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <deque>
using namespace std;
using ldouble = long double;

int p;
string a, b;

int get_digit(char c)
{
    if(c>='0' && c<='9')return c-'0';
    if(c>='a' && c<='z')return c-'a';
    if(c>='A' && c<='Z')return c-'A';
    return 0;
}

char give_digit(int index)
{
    if(index<10)return '0'+index;
    else return 'A'+index-10;
}

ldouble convert(const string &s)
{
    ldouble result = 0;
    bool dotted = false;
    ldouble ld = 5;

    int periodStart = -1;
    int periodLen;

    for(int i=0, afterPeriod = 0;i<2000;i++)
    {
        if(s[i]=='.')dotted = true;
        else if(s[i]=='(')
        {
            if(periodStart==-1)
            {
                periodStart = i+1;
                periodLen = s.size() -i -2;
                //printf("perLen: %d\n", periodLen);
            }
        }
        else
        {
            char digChar = '_';
            if(i<s.size() && s[i]!=')')digChar = s[i];
            else
            {
                digChar = s[periodStart + afterPeriod%periodLen];
            }

            //printf("%c ", digChar);

            if(!dotted)result = result * p + get_digit(digChar);
            else
            {
                result += get_digit(digChar)/ld;
                ld*=p;
            }

            if(periodStart!=-1)afterPeriod++;
        }
    }

    return result;
}

string to_string(ldouble value, int precision)
{
    stringstream stream;
    stream<<setprecision(precision)<<value;
    return stream.str();
}

int dot_index(const string &s)
{
    for(int i=0;i<s.size();i++)if(s[i]=='.') return i;
    return s.size();
}

string convert(ldouble value)
{
    string s10 = to_string(value, 2000);
    int dotIndex = dot_index(s10);

    double pths = value * p;

    deque<char> res;

    double q = pow((double)p, 20);
    double minQ = pow((double)p, -20);

    int wholeDigits=-1;

    int mq = 20;
    while(q>=minQ)
    {
        mq--;
        if(q<=pths)
        {
            wholeDigits=max(wholeDigits, mq);
            int digit = pths/(q);
            //cout<<"q: "<<q<<"   d:  "<<digit<<endl;
            res.push_back(give_digit(digit));
            pths-=q*digit;
        }

        if(q==1)
        {
            while(wholeDigits>=2)
            {
                res.push_back('0');
                wholeDigits--;
            }
            res.push_back('.');
        }
        q/=p;
    }

    if(res.back()=='.')res.pop_back();

    return {res.begin(), res.end()};
}

void solve()
{
    //cout<<convert(a)<<endl;
    //cout<<convert(b)<<endl;
    double result = convert(a) + convert(b);
    cout<<convert(result)<<endl;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>p>>a>>b;
    solve();
}
/**
5
1242.1(2)
002.322(22)
**/
