#include<iostream>
#include<algorithm>
#include<vector>
using namespace std;

struct Edge
{
    int a,b;
    int s;
};
struct Edge2
{
    int to;
    int s;
};
const int MAX_N=50100;
const int MAX_M=200100;
int n,m,k;
Edge e[MAX_M];
vector<Edge2> v[MAX_N];

bool cmp(Edge& a, Edge& b)
{
    return a.s>b.s;
}

int x=-1;
vector<int> d;

void input()
{
    cin>>n>>m>>k;
    for (int i=0;i<m;++i)
    {
        cin>>e[i].a>>e[i].b>>e[i].s;
        --e[i].a;
        --e[i].b;
        v[e[i].a].push_back({e[i].b,e[i].s});
        v[e[i].b].push_back({e[i].a,e[i].s});
    }
}
void output()
{
    cout<<x<<' '<<d.size()<<'\n';
    for (int i=0;i<d.size();++i)
    {
        if (i) cout<<' ';
        cout<<d[i]+1;
    }
}

int u[MAX_N];
int us[MAX_N];
int findu(int a)
{
    if (u[a]==a) return a;
    return u[a]=findu(u[a]);
}
bool unite(int a, int b)
{
    a=findu(a);
    b=findu(b);
    if (a==b) return 0;
    if (us[a]>us[b])
    {
        us[a]+=us[b];
        u[b]=a;
    }
    else
    {
        us[b]+=us[a];
        u[a]=b;
    }
    return 1;
}
int ap;
int ct;
int et[MAX_N];
int mt[MAX_N];
void apdfs(int p, int a, int cs, bool mode)
{
    et[a]=ct++;
    mt[a]=et[a];
    int curr;
    bool AP=0;
    int children=0;
    for (int i=0;i<v[a].size();++i)
    {
        if (v[a][i].s<=cs) continue;
        curr=v[a][i].to;
        if (et[curr]==-1)
        {
            apdfs(a,curr,cs,mode);
            ++children;
            if (p!=-1 && mt[curr]>=et[a])
            {
                AP=1;
            }
            mt[a]=min(mt[a],mt[curr]);
        }
        else if (curr!=p)
        {
            mt[a]=min(mt[a],et[curr]);
        }
    }
    if (p==-1 && children>1) AP=1;
    if (AP==1)
    {
        if (mode==0) ++ap;
        else d.push_back(a);
    }
}
int findAP(int cs, bool mode)
{
    ap=0;
    ct=0;
    for (int i=0;i<n;++i)
    {
        et[i]=-1;
        mt[i]=-1;
    }
    apdfs(-1,0,cs,mode);
    return ap;
}
void solve()
{
    int ms=0; //maximum snow before graph is not connected
    int msi=-1; //maximum snow edge index before graph is not connected
    int cs;
    sort(e,e+m,cmp);
    for (int i=0;i<n;++i)
    {
        u[i]=i;
        us[i]=1;
    }
    int edges=0;
    for (int i=0;i<m;++i)
    {
        edges+=unite(e[i].a,e[i].b);
        if (edges==n-1)
        {
            cs=e[i].s;
            for (;i<m;++i)
            {
                if (e[i].s<cs)
                {
                    ms=e[i].s;
                    msi=i;
                    break;
                }
            }
            break;
        }
    }
    //cerr<<"  "<<ms<<" "<<msi<<endl;
    int l=msi;
    int r=m;
    int mid;
    int ap;
    while (l<=r)
    {
        mid=(l+r)/2;
        if (mid<m) cs=e[mid].s;
        else cs=0;
        ap=findAP(cs,0);
        //cerr<<" "<<l<<" "<<r<<"  "<<mid<<"   "<<ap<<endl;
        //cerr<<e[l].s<<" "<<((r<m)?e[r].s:0)<<"  "<<cs<<"   "<<ap<<endl;
        if (ap>=k)
        {
            x=cs;
            l=mid+1;
        }
        else
        {
            r=mid-1;
        }
    }
    if (x!=-1)
    {
        findAP(x,1);
    }
    sort(d.begin(),d.end());
}

int main()
{
    cin.tie(0);
    ios::sync_with_stdio(0);

    input();
    solve();
    output();

    return 0;
}
