#include<iostream>
#include<vector>
using namespace std;
const long long MAX_P_SIZE=2100;
const long long MAX_P_SIZE2=2000100;
long long b;
string num1,num2;
string ans;
void input()
{
    cin>>b;
    cin>>num1>>num2;
}
void output()
{
    cout<<ans<<endl;
}

vector<long long> l1,f1,p1; //whole, fraction, period for num1
vector<long long> l2,f2,p2; //whole, fraction, period for num2
vector<long long> la,fa,pa; //whole, fraction, period for ans

void print(vector<long long>& l, vector<long long>& f, vector<long long>& p)
{
    for (long long i=0;i<l.size();++i)
    {
        cerr<<l[i]<<' ';
    }
    cerr<<". ";
    for (long long i=0;i<f.size();++i)
    {
        cerr<<f[i]<<' ';
    }
    cerr<<"( ";
    for (long long i=0;i<p.size();++i)
    {
        cerr<<p[i]<<' ';
    }
    cerr<<")\n";
}
void parse(string& num, vector<long long>& l, vector<long long>& f, vector<long long>& p)
{
    long long phase=0;
    long long curr;
    for (long long i=0; i<num.size(); ++i)
    {
        if (num[i]=='.')
            phase=1;
        else if (num[i]=='(')
            phase=2;
        else if (num[i]==')')
            break;
        else
        {
            if (num[i]>='0' && num[i]<='9')
                curr=num[i]-'0';
            else
                curr=num[i]-'A'+10;
            if (phase==0)
                l.push_back(curr);
            else if (phase==1)
                f.push_back(curr);
            else
                p.push_back(curr);
        }
    }
    if (p.size()==0) p.push_back(0);
}
void add_whole()
{
    long long d1,d2;
    long long c=0;
    la.resize(max(l1.size(),l2.size())+1);
    for (long long i=0; i<la.size(); ++i)
    {
        if (i<l1.size()) d1=l1[l1.size()-1-i];
        else d1=0;
        if (i<l2.size()) d2=l2[l2.size()-1-i];
        else d2=0;
        la[la.size()-i-1]=d1+d2+c;
        c=la[la.size()-i-1]/b;
        la[la.size()-i-1]%=b;
    }
}
long long found[MAX_P_SIZE][MAX_P_SIZE];
long long get_d(long long& i, long long& phase, vector<long long>& f, vector<long long>& p)
{
    long long d;
    if (phase==0)
    {
        d=f[i];
        ++i;
        if (i==f.size())
        {
            i=0;
            phase=1;
        }
    }
    else if (phase==1)
    {
        d=p[i];
        i=(i+1)%p.size();
    }
    return d;
}
void add_fandp()
{
    long long d1,d2;
    long long p_start=-1;
    long long phase1=0;
    long long phase2=0;
    long long i1=0;
    long long i2=0;
    long long pos=0;
    for (long long i=0;i<p1.size();++i)
    {
        for (long long j=0;j<p2.size();++j)
        {
            found[i][j]=-1;
        }
    }
    if (f1.size()==0) phase1=1;
    if (f2.size()==0) phase2=1;
    while(1)
    {
        if (phase1==1 && phase2==1)
        {
            if (found[i1][i2]>=0)
            {
                p_start=found[i1][i2];
                break;
            }
            found[i1][i2]=pos;
        }
        d1=get_d(i1,phase1,f1,p1);
        d2=get_d(i2,phase2,f2,p2);
        fa.push_back(d1+d2);
        ++pos;
    }
    pa.resize(0ll+fa.size()-p_start);
    for (long long i=p_start;i<fa.size();++i)
    {
        pa[i-p_start]=fa[i];
    }
    fa.resize(p_start);
}
void perform_carry()
{
    long long c=1;
    for (long long i=0ll+pa.size()-1;i>=0;--i)
    {
        c=(c+pa[i])/b;
    }
    for (long long i=0ll+pa.size()-1;i>=0;--i)
    {
        pa[i]+=c;
        c=pa[i]/b;
        pa[i]%=b;
    }
    for (long long i=0ll+fa.size()-1;i>=0;--i)
    {
        fa[i]+=c;
        c=fa[i]/b;
        fa[i]%=b;
    }
    for (long long i=0ll+la.size()-1;i>=0;--i)
    {
        la[i]+=c;
        c=la[i]/b;
        la[i]%=b;
    }
}
void add()
{
    add_whole();
    //print(la,fa,pa);
    add_fandp();
    //print(la,fa,pa);
    perform_carry();
}
void simplify_whole()
{
    long long lz=0;
    for (long long i=0;i<la.size();++i)
    {
        if (la[i]==0) ++lz;
        else break;
    }
    if (lz==la.size()) --lz;
    for (long long i=0;i<la.size()-lz;++i)
    {
        la[i]=la[i+lz];
    }
    la.resize(la.size()-lz);
}
long long fl[MAX_P_SIZE2];
void simplify_period()
{
    fl[0]=-1;
    fl[1]=0;
    long long curr=0;
    long long p;
    for (long long i=1;i<pa.size();++i)
    {
        while (curr!=-1 && pa[i]!=pa[curr]) curr=fl[curr];
        ++curr;
        fl[i+1]=curr;
    }
    p=pa.size()-fl[pa.size()];
    if (pa.size()%p==0) pa.resize(p);
}
vector<long long> pa2;
void simplify_fraction()
{
    long long i=pa.size()-1;
    long long shift=0;
    while (shift<fa.size() && fa[fa.size()-1-shift]==pa[i])
    {
        i=(i-1+pa.size())%pa.size();
        shift++;
    }
    fa.resize(fa.size()-shift);
    shift%=pa.size();
    pa2.resize(pa.size());
    for (long long i=0;i<pa.size();++i)
    {
        pa2[i]=pa[(i-shift+pa.size())%pa.size()];
    }
    for (long long i=0;i<pa.size();++i)
    {
        pa[i]=pa2[i];
    }
    if (pa.size()==1 && pa[0]==0) pa.resize(0);
}
void simplify()
{
    simplify_whole();
    simplify_period();
    simplify_fraction();
}
char get_symbol(long long d)
{
    if (d<10) return '0'+d;
    else return 'A'+d-10;
}
void get_ans()
{
    for (long long i=0;i<la.size();++i)
    {
        ans+=get_symbol(la[i]);
    }
    if (fa.size() || pa.size()) ans+='.';
    for (long long i=0;i<fa.size();++i)
    {
        ans+=get_symbol(fa[i]);
    }
    if (pa.size()) ans+='(';
    for (long long i=0;i<pa.size();++i)
    {
        ans+=get_symbol(pa[i]);
    }
    if (pa.size()) ans+=')';
}
void solve()
{
    parse(num1,l1,f1,p1);
    parse(num2,l2,f2,p2);
    //print(l1,f1,p1);
    //print(l2,f2,p2);
    add();
    //print(la,fa,pa);
    simplify();
    //print(la,fa,pa);
    get_ans();
}

int main()
{
    cin.tie(0);
    ios::sync_with_stdio(0);

    input();
    solve();
    output();

    return 0;
}
