#include<iostream>
#include<algorithm>
#include<string>
using namespace std;
int toNum(char c){
	if(c>='0'&&c<='9') return c-'0';
	return 10+c-'A';
}
char toChar(char c){
	if(c>=0&&c<=9) return c+'0';
	return c-10+'A';
}
void addToPeriod(string &frac, string &per){
	if(per.size()==0) return;
	int fracL=frac.size()-1;
	int perL=per.size()-1;
	int cnt=0;
	while(fracL>=0&&frac.size()!=0&&frac[fracL]==per[perL]){
		cnt++;
		perL--;
		fracL--;
		per.pop_back();
	}
	per=frac.substr(fracL+1,cnt)+per;
	for(int i=0;i<cnt;i++) frac.pop_back();
}
const int MOD1=1e9+7,MOD2=1e9+9;
const int mult1=43,mult2=41;
long long hashes1[3001],hashes2[3001],pow1[3001],pow2[3001];
pair<long long,long long> substrHash(int from,int to){
	pair<long long, long long> ans=make_pair(hashes1[to+1],hashes2[to+1]);
	ans.first=(ans.first+MOD1)-hashes1[from]*pow1[to-from+1]%MOD1;
	ans.first%=MOD1;

	ans.second=(ans.second+MOD2)-hashes2[from]*pow2[to-from+1]%MOD2;
	ans.second%=MOD2;
	return ans;
}
bool checkTemp(string &per,int len){
	pair<long long,long long> temp=substrHash(0,len-1);
	for(int j=len;j<per.size();j+=len){
		if(substrHash(j,j+len-1)!=temp) return false;
	}
	return true;
}
void fixPeriod(string &per){
	hashes1[0]=0;
	hashes2[0]=0;
	pow1[0]=1;
	pow2[0]=1;
	for(int i=0;i<per.size();i++){
		hashes1[i+1]=hashes1[i]*mult1+toNum(per[i])+1;
		hashes1[i+1]%=MOD1;
		pow1[i+1]=pow1[i]*mult1;
		pow1[i+1]%=MOD1;

		hashes2[i+1]=hashes2[i]*mult2+toNum(per[i])+1;
		hashes2[i+1]%=MOD2;
		pow2[i+1]=pow2[i]*mult2;
		pow2[i+1]%=MOD2;
	}
	int div=per.size();
	for(int i=1;i*i<=div;i++){
		if(div%i==0){
			if(checkTemp(per,i)){
				per=per.substr(0,i);
				return;
			}else{
				if(checkTemp(per,div-i)){
					per=per.substr(0,div-i);
				}
				div=per.size();
			}
		}
		while(div%i==0) div/=i;
	}
	if(div!=1){
		if(checkTemp(per,div)){
			per=per.substr(0,div);
		}
	}
}
int base;
void getNum(string input,string num[]){
	int ind=0;
	for(int i=0;i<input.size();i++){
		if(input[i]=='.'||input[i]=='('){
			ind++;
		}
		if((input[i]>='0'&&input[i]<='9')||(input[i]>='A'&&input[i]<='Z')){
			if(ind==0&&num[ind]==""&&input[i]=='0') continue;
			num[ind]+=input[i];
		}
	}
	addToPeriod(num[1],num[2]);
	fixPeriod(num[2]);
	if(num[2].size()==1&&num[2][0]==toChar(base-1)){
		num[2]="";
		int j=num[1].size();
		while(j>0&&num[1][j-1]==toChar(base-1)){
			num[1][j-1]='0';
			j--;
		}
		if(j==0){
			j=num[0].size();
			while(j>0&&num[0][j-1]==toChar(base-1)){
				num[0][j-1]='0';
				j--;
			}
			if(j==0){
				num[0]+='1';
			}else{
				num[0][j-1]=toChar(toNum(num[0][j-1])+1);
			}
		}else{
			num[1][j-1]=toChar(toNum(num[1][j-1])+1);
		}
	}
}
int main(){
	cin.tie(NULL);
	ios::sync_with_stdio(false);
	cin>>base;
	string str;
	string num1[3],num2[3];
	cin>>str;
	getNum(str,num1);
	cin>>str;
	getNum(str,num2);
	int begInd=0;
	while(num1[1].size()<num2[1].size()){
		if(num1[2]==""){
			num1[1]+='0';
		}else{
			num1[1]+=num1[2][begInd];
			num1[2]+=num1[2][begInd];
			begInd++;
			begInd%=num1[2].size();
		}
	}
	num1[2].erase(0,begInd);
	begInd=0;
	while(num1[1].size()>num2[1].size()){
		if(num2[2]==""){
			num2[1]+='0';
		}else{
			num2[1]+=num2[2][begInd];
			num2[2]+=num2[2][begInd];
			begInd++;
			begInd%=num2[2].size();
		}
	}
	num2[2].erase(0,begInd);
	string ans[3];
	int prenos=0;
	if(num2[2].size()==0){
		ans[2]=num1[2];
	}else{
		if(num1[2].size()==0){
			ans[2]=num2[2];
		}else{
			int len1=num1[2].size(),len2=num2[2].size();
			long long r=1,pom1=len1,pom2=len2;
			while(r!=0){
				r=pom1%pom2;
				pom1=pom2;
				pom2=r;
			}
			long long mul=len1*len2/pom1;
			int i=len1-1,j=len2-1;
			for(int p=0;p<mul;p++){
				int val=toNum(num1[2][i])+toNum(num2[2][j])+prenos;
				prenos=val/base;
				val%=base;
				ans[2]=ans[2]+toChar(val);
				i=(i+len1-1)%len1;
				j=(j+len2-1)%len2;
			}
			if(prenos){
				int last=0;
				while(last<mul&&ans[2][last]==toChar(base-1)){
					ans[2][last]='0';
					last++;
				}
				if(last==mul){
					ans[2]="";
				}else{
					ans[2][last]=toChar(toNum(ans[2][last])+1);
				}
			}
			reverse(ans[2].begin(),ans[2].end());
		}
	}
	bool toOne=true,zeros2=true;
	for(int i=0;i<ans[2].size();i++){
		if(ans[2][i]!=toChar(base-1)) toOne=false;
		if(ans[2][i]!='0') zeros2=false;
	}
	if(toOne&&ans[2].size()!=0){
		prenos++;
		ans[2]="";
	}
	if(zeros2&&ans[2].size()!=0) ans[2]="";
	for(int i=num1[1].size();i>0;i--){
		int val=toNum(num1[1][i-1])+toNum(num2[1][i-1])+prenos;
		prenos=val/base;
		val%=base;
		ans[1]+=toChar(val);
	}
	bool zeros=true;
	for(int i=0;i<ans[1].size();i++){
		if(ans[1][i]!='0'){
			zeros=false;
			break;
		}
	}
	reverse(ans[1].begin(),ans[1].end());
	addToPeriod(ans[1],ans[2]);
	fixPeriod(ans[2]);
	int i=num1[0].size()-1;
	int j=num2[0].size()-1;
	while(i>=0||j>=0){
		int val=prenos;
		if(i>=0){
			val+=toNum(num1[0][i]);
			i--;
		}
		if(j>=0){
			val+=toNum(num2[0][j]);
			j--;
		}
		prenos=val/base;
		val%=base;
		ans[0]+=toChar(val);
	}
	if(prenos){
		ans[0]+='1';
	}
	reverse(ans[0].begin(),ans[0].end());
	if(ans[0]=="") ans[0]="0";
	cout<<ans[0];
	if((ans[1].size()!=0||ans[2].size()!=0)&&!(zeros&&ans[2].size()==0)){
		cout<<".";
		cout<<ans[1];
		if(ans[2].size()!=0){
			cout<<"("<<ans[2]<<")";
		}
	}
	cout<<"\n";
	return 0;
}

