# include <cstdio>
# include <algorithm>
# include <vector>

using namespace std;

struct nu
{
	vector <int> i;
	vector <int> r;
	vector <int> p;
};

int base;

nu A, B, C;

nu read ()
{
	nu a;
	char c;
	
	while (1)
	{
		scanf ("%c", &c);
		if (c == '.')
			break;
		if (c == '(')
			break;
		if (c == '\n')
			break;
		if (c >= '0' && c <= '9')
			a.i.push_back (c - '0');
		if (c >= 'A' && c <= 'Z')
			a.i.push_back (c - 'A');
	}
	reverse (a.i.begin (), a.i.end ());
	
	if (c == '.')
	{
		while (1)
		{
			scanf ("%c", &c);
			if (c == '(')
				break;
			if (c == '\n')
				break;
			if (c >= '0' && c <= '9')
				a.r.push_back (c - '0');
			if (c >= 'A' && c <= 'Z')
				a.r.push_back (c - 'A');
		}
		///reverse (a.r.begin (), a.r.end ());
	}
	
	if (c == '(')
	{
		while (1)
		{
			scanf ("%c", &c);
			if (c == '\n')
				break;
			if (c >= '0' && c <= '9')
				a.p.push_back (c - '0');
			if (c >= 'A' && c <= 'Z')
				a.p.push_back (c - 'A');
		}
		reverse (a.p.begin (), a.p.end ());
	}
	
	return a;
}

void print ()
{
	int i;

	printf ("###############################\n");
	
	for (i = 0; i < (int) A.i.size (); i ++)
		printf ("%d", A.i[i]);
	printf ("\n");
	
	for (i = 0; i < (int) A.r.size (); i ++)
		printf ("%d", A.r[i]);
	printf ("\n");
	
	for (i = 0; i < (int) A.p.size (); i ++)
		printf ("%d", A.p[i]);
	printf ("\n");


	for (i = 0; i < (int) B.i.size (); i ++)
		printf ("%d", B.i[i]);
	printf ("\n");
	
	for (i = 0; i < (int) B.r.size (); i ++)
		printf ("%d", B.r[i]);
	printf ("\n");
	
	for (i = 0; i < (int) B.p.size (); i ++)
		printf ("%d", B.p[i]);
	printf ("\n");
	
	for (i = 0; i < (int) C.i.size (); i ++)
		printf ("%d", C.i[i]);
	printf ("\n");
	
	for (i = 0; i < (int) C.r.size (); i ++)
		printf ("%d", C.r[i]);
	printf ("\n");
	
	for (i = 0; i < (int) C.p.size (); i ++)
		printf ("%d", C.p[i]);
	printf ("\n");
}

int to_i, to_r;

void adjust_r ()
{
	int i, j, k, sz_a = A.r.size (), sz_b = B.r.size (), sz, fl = to_r, cd;
	
	if (!A.p.size () || !B.p.size ())
	{
		for (i = 0; i < (sz_b - sz_a); i ++)
			A.r.push_back (0);
	
		for (i = 0; i < (sz_a - sz_b); i ++)
			B.r.push_back (0);
		return;
	}
	
	for (k = 0; ; k ++)
		if (!((sz_b + k * B.p.size () - sz_a) % A.p.size ()))
			break;
			
	for (i = 0; i < k; i ++)
		for (j = 0; j < (int) B.p.size (); j ++)
			B.r.push_back (B.p[j]);

	while (A.r.size () < sz_b + k * B.p.size ())
	{
		for (j = 0; j < (int) A.p.size (); j ++)
			A.r.push_back (A.p[j]);
	}
}

int mgcd (int aa, int bb)
{
	int cc;
	while (bb)
	{
		cc = bb;
		bb = aa % bb;
		aa = cc;
	}
	return aa;
}

void adjust_p ()
{
	int i, j, k, sz_a = A.p.size (), sz_b = B.p.size (), sz, fl = to_r, cd;
	
	if (!sz_a || !sz_b)
	{
		for (i = 0; i < (sz_b - sz_a); i ++)
			A.p.push_back (0);
	
		for (i = 0; i < (sz_a - sz_b); i ++)
			B.p.push_back (0);
		return;
	}
	
	int g = (sz_a * sz_b) / mgcd (sz_a, sz_b);
	
	
	
	while (A.p.size () < g)
		for (j = 0; j < sz_a; j ++)
			A.p.push_back (A.p[j]);
			
	while (B.p.size () < g)
		for (j = 0; j < sz_b; j ++)
			B.p.push_back (B.p[j]);
}

void add_i ()
{
	int i, sz_a = A.i.size (), sz_b = B.i.size (), cd;
	
	for (i = 0; i < (sz_b - sz_a); i ++)
		A.i.push_back (0);
	
	for (i = 0; i < (sz_a - sz_b); i ++)
		B.i.push_back (0);	
		
	for (i = 0; i < (int) A.i.size (); i ++)
	{
		cd = A.i[i] + B.i[i] + to_i;
		if (cd >= base)
		{
			cd -= base;
			to_i = 1;
		}
		else
			to_i = 0;
		
		C.i.push_back (cd);
	}
	
	if (to_i)
		C.i.push_back (to_i);
}

void add_r ()
{
	int i, sz_a = A.r.size (), sz_b = B.r.size (), cd;
	
	for (i = 0; i < (sz_b - sz_a); i ++)
		A.r.push_back (0);
	
	for (i = 0; i < (sz_a - sz_b); i ++)
		B.r.push_back (0);	
		
	for (i = 0; i < (int) A.r.size (); i ++)
	{
		cd = A.r[i] + B.r[i] + to_r;
		if (cd >= base)
		{
			cd -= base;
			to_r = 1;
		}
		else
			to_r = 0;
		
		C.r.push_back (cd);
	}
	
	if (to_r)
		to_i = 1;
}

void add_p ()
{
	int i, sz_a = A.p.size (), sz_b = B.p.size (), cd, to_p = 0;
	
	for (i = 0; i < (int) A.p.size (); i ++)
	{
		cd = A.p[i] + B.p[i] + to_p;
		if (cd >= base)
		{
			cd -= base;
			to_p = 1;
		}
		else
			to_p = 0;
		
		C.p.push_back (cd);
	}
	
	for (i = 0; i < (int) C.p.size (); i ++)
		if (C.p[i] != (base - 1))
			break;
		
	if (i == int (C.p.size ()) &&  C.p.size ())
	{
		to_r = 1;
		C.p.clear ();
		return;
	}
	
	for (i = 0; i < (int) C.p.size (); i ++)
		if (C.p[i])
			break;
	
	if (i == int (C.p.size ()))
	{
		to_r = to_p;
		C.p.clear ();
		return;
	}
	
	
	if (to_p)
	{
		to_r = 1;
		C.p[0] ++;
	}
}

const int BASE = 41;

unsigned long long ch[2000000];
unsigned long long bp[2000000];

void try_to_shorten (nu &X)
{
	int i, sz = X.p.size ();
	unsigned long long hashl = 0, hashr = 0;
	bp[0] = 1;
	for (i = 0; i < sz; i ++)
	{
		bp[i + 1] = bp[i] * BASE;
		hashl *= BASE;
		hashl += (X.p[i] + 1);
		ch[i] = hashl;
		///printf ("--- %d %llu\n", i, ch[i]);
	}
	
	hashr = ch[sz - 1];
	
	for (i = 0; ((i + 0) << 1) < sz; i ++)
	{
		hashr -= bp[sz - i - 1] * (X.p[i] + 1);
		hashl = ch[sz - i - 2];
		
		///printf ("%d %llu %llu\n", i, hashr, hashl);
		
		if (hashr == hashl)
			break;
	}
	
	if (((i + 0) << 1) < sz)
	{
	
		///printf ("---- %d\n", i + 1);
	
		while (X.p.size () > (i + 1))
			X.p.pop_back ();
	}	
}

void rem_from_r (nu &X)
{
	int i, j, st = 0;
	
	if (!X.p.size ())
		return;
		
	while (st + X.p.size () <= X.r.size ())
	{
		for (i = 0; i < (int) X.p.size (); i ++)
			if (X.r[st + i] != X.p[i])
				break;
		if (i < (int) X.p.size ())
			break;
		st += X.p.size ();
	}
	
	vector <int> nr;
	
	for (i = st; i < (int) X.r.size (); i ++)
		nr.push_back (X.r[i]);
	X.r.clear ();
	X.r = nr;
}


int main ()
{
	int i;
	
	scanf ("%d\n", &base);
	
	
	A = read ();
	B = read ();
	
	///print ();
	
	
	///try_to_shorten (A);
	///rem_from_r (A);
	
	
	///try_to_shorten (B);
	///rem_from_r (B);
	
	///print ();
	
	adjust_r ();
	adjust_p ();
	
	reverse (A.r.begin (), A.r.end ());
	reverse (B.r.begin (), B.r.end ());
	
	add_p ();
	add_r ();
	add_i ();	
	
	///print ();
	
	try_to_shorten (C);
	rem_from_r (C);
	
	///print ();
	
	int last = 0;
	
	for (i = 0; i < (int) C.i.size (); i ++)
		if (C.i[i] != 0)
			last = i;
	
	for (i = last; i >= 0; i --)
	{
		if (C.i[i] < 10)
			printf ("%d", C.i[i]);
		else
			printf ("%c", char (C.i[i] - 10 + 'A')); 
	}
	
	i = 0;
	if (!C.p.size ())
		for (i = 0; i < (int) C.r.size (); i ++)
			if (C.r[i])
				break;
	last = i;
	
	if (last < C.r.size ())
	{
		printf (".");
	
		for (i = C.r.size () - 1; i >= last; i --)
		{
			if (C.r[i] < 10)
				printf ("%d", C.r[i]);
			else
				printf ("%c", char (C.r[i] - 10 + 'A')); 
		}
	}
	
	if (C.p.size ())
	{
		printf ("(");
		
		for (i = C.p.size () - 1; i >= 0; i --)
		{
			if (C.p[i] < 10)
				printf ("%d", C.p[i]);
			else
				printf ("%c", char (C.p[i] - 10 + 'A')); 
		}
			
		printf (")");
	}
	
	printf ("\n");	

	return 0;
}

