#include <bits/stdc++.h>
#define endl '\n'
#define time jhakghkajgaag

using namespace std;

const int N = 50007;

struct edge {
    int a,b,s;

    edge(){}
    edge(int x, int y, int z): a(x), b(y), s(z) {}

    bool operator <(const edge &a) const {
        return s>a.s;
    }
};

int n,m,k,trees;
vector < edge > edges;
map < pair < int, int >, int > edge_cost;
int parents[N],sz[N];
vector < int > v[N];
int current_time;
int parent[N],low[N],time[N];
bool used[N];
bool is[N];

void initialize_dsu() {
    for(int i=1;i<=n;i++) {
        parents[i]=i;
        sz[i]=1;
    }
}

int find(int x) {
    while(x!=parents[x]) {
        parents[x]=parents[parents[x]];
        x=parents[x];
    }
    return x;
}

bool join(int x, int y) {
    x=find(x);
    y=find(y);

    if(x==y) return false;
    
    if(sz[x]<sz[y]) swap(x,y);
    sz[x]+=sz[y];
    parents[y]=x;

    return true;
}

void dfs(int node) {
    used[node]=true;
    low[node]=time[node]=++current_time;
    
    int i,cnt=0,max_low=0;

    for(i=0;i<(int)(v[node].size());i++) if(v[node][i]!=parent[node]) {
        if(used[v[node][i]]) {
            low[node]=min(low[node],time[v[node][i]]);
        }
        else {
            ++cnt;
            parent[v[node][i]]=node;
            dfs(v[node][i]);
            low[node]=min(low[node],low[v[node][i]]);
            max_low=max(max_low,low[v[node][i]]);
        }
    }

    if(parent[node]==-1) {
        is[node]=(cnt>1);
    }
    else {
        is[node]=(max_low>time[parent[node]]);
    }
}

int count_them(int threshold) {
    int i,ans=0;

    for(i=1;i<=n;i++) {
        is[i]=false;
        used[i]=false;
        v[i].clear();
    }

    current_time=0;
    parent[1]=-1;
   
    for(i=0;i<(int)(edges.size());i++) if(edges[i].s>threshold) {
        v[edges[i].a].push_back(edges[i].b);
        v[edges[i].b].push_back(edges[i].a);
    }

    dfs(1);

    for(i=1;i<=n;i++) if(is[i]) ++ans;

    return ans;
}

void restore(int threshold) {
    int i;
    vector < int > ans;

    for(i=1;i<=n;i++) {
        used[i]=false;
        is[i]=false;
        v[i].clear();
    }

    current_time=0;
    parent[1]=-1;

    for(i=0;i<(int)(edges.size());i++) if(edges[i].s>threshold) {
        v[edges[i].a].push_back(edges[i].b);
        v[edges[i].b].push_back(edges[i].a);
    }

    dfs(1);

    for(i=1;i<=n;i++) if(is[i]) ans.push_back(i);

    printf("%d %d\n", threshold, (int)(ans.size()));
    for(i=0;i<(int)(ans.size());i++) {
        if(i>0) printf(" ");
        printf("%d", ans[i]);
    }
    printf("\n");
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int i,x,y,z;

    scanf("%d %d %d", &n, &m, &k);
    for(i=1;i<=m;i++) {
        scanf("%d %d %d", &x, &y, &z);
        if(x==y) continue;
        if(x>y) swap(x,y);
        //edge_cost[make_pair(x,y)]=max(edge_cost[make_pair(x,y)],z);
        edges.push_back(edge(x,y,z));
    }
    
    for(map < pair < int, int >, int >::iterator it=edge_cost.begin();it!=edge_cost.end();it++) {
        edges.push_back(edge(it->first.first,it->first.second,it->second));
    }

    sort(edges.begin(),edges.end());
    m=(int)(edges.size());

    initialize_dsu();
    trees=n;
    for(i=0;i<(int)(edges.size());i++) {
        if(join(edges[i].a,edges[i].b)) {
            --trees;
            if(trees==1) break;
        }
    }

    if(i==(int)(edges.size())) {
        printf("-1 0\n");
        return 0;
    }

    if(count_them(edges[i].s-1)<k) {
        printf("-1 0\n");
        return 0;
    }

    int left=-1,right=edges[i].s-1,middle;

    while(right-left>1) {
        middle=(left+right)>>1;
        if(count_them(middle)>=k) right=middle;
        else left=middle;
    }

    restore(right);

    return 0;
}
