#include "hunter.h"
#include <iostream>
#include <vector>
#include <utility>
using namespace std;

//pair<int,int> makeMove(int,int) {}

pair<int,int> findOdd(const vector<char>& table)
{
    pair<int,int> res(-1,-1);
    for(size_t i=0; i<table.size(); ++i)
        switch(table[i])
        {
        case '.':
            if(res.first==-1) res.first=res.second=i;
            else ++res.second;
            break;
        case '#':
            if(!(res.second-res.first&1)) return res;
            res.first=-1;
        }
    if(!(res.second-res.first&1)) return res;
    return make_pair(-1,-1);
}
//vector<vector<char>> help;
int n, m;
void isOddHelp(vector<vector<char>>& table, int i, int j, char f, int& c)
{
    table[i][j]=f;
    ++c;
    if(i && table[i-1][j]!='#' && table[i-1][j]!=f) isOddHelp(table,i-1,j,f,c);
    if(j<m-1 && table[i][j+1]!='#' && table[i][j+1]!=f) isOddHelp(table,i,j+1,f,c);
    if(i<n-1 && table[i+1][j]!='#' && table[i+1][j]!=f) isOddHelp(table,i+1,j,f,c);
    if(j && table[i][j-1]!='#' && table[i][j-1]!=f) isOddHelp(table,i,j-1,f,c);
}

bool isOdd(vector<vector<char>>& table, int i, int j)
{
    char f=table[i][j]!=1? 1: 2;
    int c=0;
    isOddHelp(table,i,j,f,c);
    return c&1;
}

void play(int n, int m, const vector<vector<char>>& table)
{
    ::n=n;
    ::m=m;
    if(n==1)
    {
        pair<int,int> t=findOdd(table[0]), p;
        if(t.first==-1)
        {
            p=makeMove(-1,-1);
            vector<char> t2=table[0];
            t2[p.second]='#';
            t=findOdd(t2);
            int i=0;
            if(t.first>p.second)
                do
                {
                    p=makeMove(0,t.first+i);
                    i+=2;
                }
                while(p.first!=-1);
            else
                do
                {
                    p=makeMove(0,t.second-i);
                    i+=2;
                }
                while(p.first!=-1);
        }
        else
        {
            int i=0;
            p=makeMove(0,t.first);
            while(p.first!=-1)
            {
                i+=2;
                p=makeMove(0,t.first+i);
            }
        }
    }
    else
    {
        vector<vector<char>> t2=table;
        pair<int,int> p;
        if(!(n*m&1))
        {
            p=makeMove(-1,-1);
            while(p.first!=-1)
            {
                t2[p.first][p.second]='#';
                if(p.first && t2[p.first-1][p.second]!='#')
                {
                    int i=p.first-1, j=p.second;
                    t2[i][j]='#';
                    if(i && t2[i-1][j]!='#' && isOdd(t2,i-1,j)) goto lbl;
                    if(j<m-1 && t2[i][j+1]!='#' && isOdd(t2,i,j+1)) goto lbl;
                    if(i<n-1 && t2[i+1][j]!='#' && isOdd(t2,i+1,j)) goto lbl;
                    if(j && t2[i][j-1]!='#' && isOdd(t2,i,j-1)) goto lbl;
                    p=makeMove(i,j);
                    continue;
                lbl:
                    t2[i][j]='.';
                }
                else if(p.second<m-1 && t2[p.first][p.second+1]!='#')
                {
                    int i=p.first, j=p.second+1;
                    t2[i][j]='#';
                    if(i && t2[i-1][j]!='#' && isOdd(t2,i-1,j)) goto lbl2;
                    if(j<m-1 && t2[i][j+1]!='#' && isOdd(t2,i,j+1)) goto lbl2;
                    if(i<n-1 && t2[i+1][j]!='#' && isOdd(t2,i+1,j)) goto lbl2;
                    if(j && t2[i][j-1]!='#' && isOdd(t2,i,j-1)) goto lbl2;
                    p=makeMove(i,j);
                    continue;
                lbl2:
                    t2[i][j]='.';
                }
                else if(p.first<n-1 && t2[p.first+1][p.second]!='#')
                {
                    int i=p.first+1, j=p.second;
                    t2[i][j]='#';
                    if(i && t2[i-1][j]!='#' && isOdd(t2,i-1,j)) goto lbl3;
                    if(j<m-1 && t2[i][j+1]!='#' && isOdd(t2,i,j+1)) goto lbl3;
                    if(i<n-1 && t2[i+1][j]!='#' && isOdd(t2,i+1,j)) goto lbl3;
                    if(j && t2[i][j-1]!='#' && isOdd(t2,i,j-1)) goto lbl3;
                    p=makeMove(i,j);
                    continue;
                lbl3:
                    t2[i][j]='.';
                }
                else p=makeMove(p.first,p.second-1), t2[p.first][p.second-1]='#';
            }
        }
        else
        {
            p=makeMove(0,0);
            t2[0][0]='#';
            while(p.first!=-1)
            {
                t2[p.first][p.second]='#';
                if(p.first && t2[p.first-1][p.second]!='#')
                {
                    int i=p.first-1, j=p.second;
                    t2[i][j]='#';
                    if(i && t2[i-1][j]!='#' && isOdd(t2,i-1,j)) goto lbl4;
                    if(j<m-1 && t2[i][j+1]!='#' && isOdd(t2,i,j+1)) goto lbl4;
                    if(i<n-1 && t2[i+1][j]!='#' && isOdd(t2,i+1,j)) goto lbl4;
                    if(j && t2[i][j-1]!='#' && isOdd(t2,i,j-1)) goto lbl4;
                    p=makeMove(i,j);
                    continue;
                lbl4:
                    t2[i][j]='.';
                }
                if(p.second<m-1 && t2[p.first][p.second+1]!='#')
                {
                    int i=p.first, j=p.second+1;
                    t2[i][j]='#';
                    if(i && t2[i-1][j]!='#' && isOdd(t2,i-1,j)) goto lbl5;
                    if(j<m-1 && t2[i][j+1]!='#' && isOdd(t2,i,j+1)) goto lbl5;
                    if(i<n-1 && t2[i+1][j]!='#' && isOdd(t2,i+1,j)) goto lbl5;
                    if(j && t2[i][j-1]!='#' && isOdd(t2,i,j-1)) goto lbl5;
                    p=makeMove(i,j);
                    continue;
                lbl5:
                    t2[i][j]='.';
                }
                if(p.first<n-1 && t2[p.first+1][p.second]!='#')
                {
                    int i=p.first+1, j=p.second;
                    t2[i][j]='#';
                    if(i && t2[i-1][j]!='#' && isOdd(t2,i-1,j)) goto lbl6;
                    if(j<m-1 && t2[i][j+1]!='#' && isOdd(t2,i,j+1)) goto lbl6;
                    if(i<n-1 && t2[i+1][j]!='#' && isOdd(t2,i+1,j)) goto lbl6;
                    if(j && t2[i][j-1]!='#' && isOdd(t2,i,j-1)) goto lbl6;
                    p=makeMove(i,j);
                    continue;
                lbl6:
                    t2[i][j]='.';
                }
                p=makeMove(p.first,p.second-1), t2[p.first][p.second-1]='#';
            }
        }
    }
}
/*static int n__, m__;
static char t__[128][128];
int main()
{
    cin>>n__>>m__;
    ::n=n__;
    ::m=m__;
    for (int i=0; i<n__; ++i){
        cin>>t__[i];
    }
    vector<vector<char> > table;
    table.resize(n__);
    for (int i=0; i<n__; ++i){
        table[i].resize(m__);
        for (int j=0; j<m__; ++j){
            table[i][j] = t__[i][j];
        }
    }
    cin >> n__ >> m__;
    cout << isOdd(table,n__,m__) << endl;
    for(auto&& i: table)
    {
        for(char c: i) cout << c;
        cout << endl;
    }
    cin >> n__ >> m__;
    cout << isOdd(table,n__,m__) << endl;
    for(auto&& i: table)
    {
        for(char c: i) cout << c;
        cout << endl;
    }
}*/
