#include <iostream>
#include <vector>
#include <deque>
using namespace std;

const char* alpha="0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
int get_dig (char c)
{
    if(c>='A' && c<='Z') return c-'A'+10;
    return c-'0';
}
class Number
{
    deque <int> dig;
    int base;
public:
    Number (const string& s, int base): base(base)
    {
        for(const auto& i: s) dig.push_back(get_dig(i));
    }
    Number (const deque<int>& dig, int base): dig(dig), base(base) {}
    Number (deque<int>&& dig, int base): dig(move(dig)), base(move(base)) {}
    friend ostream& operator<< (ostream& os, const Number& n)
    {
        for(const auto& i: n.dig) os << alpha[i];
        return os;
    }
    Number operator+ (const Number& n) const
    {
        if(!dig.front()) return n;
        if(!n.dig.front()) return *this;
        int a[100], carry=0;
        int *p=a+100;
        auto it1=dig.rbegin();
        auto it2=n.dig.rbegin();
        while(it1!=dig.rend() && it2!=n.dig.rend())
        {
            int t=*it1+*it2+carry;
            if(t>=base) carry=1, t-=base;
            else carry=0;
            *--p=t;
            ++it1; ++it2;
        }
        while(it1!=dig.rend())
        {
            int t=*it1+carry;
            if(t>=base) carry=1, t-=base;
            else carry=0;
            *--p=t;
            ++it1;
        }
        while(it2!=n.dig.rend())
        {
            int t=*it2+carry;
            if(t>=base) carry=1, t-=base;
            else carry=0;
            *--p=t;
            ++it2;
        }
        if(carry) *--p=1;
        return Number(deque<int>(p,a+100),base);
    }
    Number operator* (int digit) const
    {
        int a[100], carry=0;
        int *p=a+100;
        for(auto it=dig.rbegin(); it!=dig.rend(); ++it)
        {
            int t=digit**it+carry;
            *--p=t%base;
            carry=t/base;
        }
        if(carry) *--p=carry;
        return Number(deque<int>(p,a+100),base);
    }
    Number operator* (const Number& n) const
    {
        Number res("0",base);
        int c=0;
        for(auto it=dig.rbegin(); it!=dig.rend(); ++it)
        {
            Number t(n**it);
            t.dig.resize(t.dig.size()+c++,0);
            res=res+t;
        }
        return res;
    }
    void remLeading0()
    {
        while(dig.size()>1 && !dig.front()) dig.pop_front();
    }
};


int main()
{
    int radix;
    cin >> radix;
    string A, B;
    cin >> A >> B;
    string a=A.substr(0,A.find('.'));
    string b=B.substr(0,B.find('.'));
    Number X(a,radix), Y(b,radix);
    X.remLeading0(); Y.remLeading0();
    cout << X+Y << endl;
}

/**
1242.1(2)
002.322(22)
*/
