#include <iostream>
#include <algorithm>

using namespace std;

unsigned base;

int to_digit (char a)
{
	if ('0' <= a and a <= '9')
		return a - '0';
	else
		return 10 + a - 'A';
}

char to_sym (int a)
{
	if (0 <= a and a <= 9)
		return a + '0';
	else
		return -10 + a + 'A';
}

struct number
{
	string I, F, P;
	number (string a)
	{
		int point = a.find ('.');
		int open = a.find ('(');
		int close = a.find (')');
		I = a.substr (0, point);
		F = a.substr (point + 1, open - point - 1);
		P = a.substr (open + 1, close - 1 - open);
		simplify ();
		simplifyP ();
	}

	void simplifyP ()
	{
		for (int len = 1 ; len <= P.size () / 2 ; len ++)
		{
			if (P.size () % len == 0)
			{
				for (int start = len ; start <= P.size () - len ; start += len)
					for (int i = 0 ; i < len ; i ++)
						if (P [i] != P [start + i])
							goto NOTTHISTIME;
				P.erase (len);
				return;
			}
			NOTTHISTIME: {}
		}
	}
	void simplify ()
	{
		int i = 0;
		for (i = 0 ; i < I.size () ; i ++)
			if (I [i] != '0')
				break;
		if (i > 0)
			I.erase (0, i);
		if (I == "")
			I = "0";
		//cout << "simplify I\'" << endl;

		for (auto& x : P)
			if (x != to_sym (base - 1))
				return;
		//cout << "simplify P" << endl;
		P = "";
		//cout << "simplify F" << endl;
		i = F.size () - 1;
		while (i >= 0 and F [i] == to_sym (base - 1))
			F.erase (i--, 1);
		//cout << i << endl;
		if (i >= 0)
			F [i] = to_sym (to_digit (F [i]) + 1);
		else
		{
			//cout << "simplify I" << endl;
			i = I.size () - 1;
			while (i >= 0 and I [i] == to_sym (base - 1))
				I [i --] = '0';
			if (i >= 0)
				I [i] = to_sym (to_digit (I [i]) + 1);
			else
				I [i] = '1' + I [i];
		}
	}
};

ostream& operator << (ostream& out, const number& a)
{
	out << a.I;
	if (a.F != "" or a.P != "")
		out << "." << a.F << "(" << a.P << ")";
	return out;
}

number operator + (number a, number b)
{
	number c ("0.0(0)");
	while (a.I.size () < b.I.size ())
		a.I = "0"+ a.I;
	while (a.I.size () > b.I.size ())
		b.I = "0"+ b.I;
	
	int api = 0, bpi = 0;
	while (a.F.size () < b.F.size ())
	{
		a.F += a.P [api];
		api = (api + 1) % a.P.size ();
	}
	while (a.F.size () > b.F.size ())
	{
		b.F += b.P [bpi];
		bpi = (bpi + 1) % b.P.size ();
	}
	
	int total_period_size = (a.P.size () * b.P.size () / __gcd (a.P.size (), b.P.size ()));
	string new_a_period;
	string new_b_period;
	
	for (int i = 0 ; i < total_period_size ; i ++)
	{
		new_a_period += a.P [api];
		api = (api + 1) % a.P.size ();
		new_b_period += b.P [bpi];
		bpi = (bpi + 1) % b.P.size ();
	}
	a.P = new_a_period;
	b.P = new_b_period;
	c.P = b.P;
	c.F = b.F;
	c.I = b.I;
	int prenos = 0;
	for (int i = total_period_size - 1 ; i >= 0 ; i --)
	{
		c.P [i] = to_sym ((to_digit (a.P [i]) + to_digit (b.P [i]) + prenos) % base);
		//cout << to_digit (a.P [i]) << " " << to_digit (b.P [i]) << " " << prenos << " " << c.P [i] << endl;
		//cout << to_digit (a.P [i]) + to_digit (b.P [i]) + prenos << " " << base << endl;
		prenos = (to_digit (a.P [i]) + to_digit (b.P [i]) + prenos) / base;
	}
	for (int i = c.F.size () - 1 ; i >= 0 ; i --)
	{
		c.F [i] = to_sym ((to_digit (a.F [i]) + to_digit (b.F [i]) + prenos) % base);
		prenos = (to_digit (a.F [i]) + to_digit (b.F [i]) + prenos) / base;
	}
	for (int i = c.I.size () - 1 ; i >= 0 ; i --)
	{
		c.I [i] = to_sym ((to_digit (a.I [i]) + to_digit (b.I [i]) + prenos) % base);
		prenos = (to_digit (a.I [i]) + to_digit (b.I [i]) + prenos) / base;
	}
	if (prenos != 0)
		c.I = to_sym (prenos) + c.I;
	//cout << a << endl;
	//cout << b << endl;
	//cout << c << endl;
	c.simplify ();
	//cout << c << endl;
	c.simplifyP ();
	//cout << c << endl;
	return c;
}

int main ()
{
	cin.tie (nullptr);
	ios::sync_with_stdio (false);
	cin >> base;
	string a, b;
	cin >> a >> b;
	number A (a), B (b);

	//cout << A << " " << B << endl;
	cout << A + B << endl;
}
