#include <iostream>
#include <vector>
#include <queue>

using namespace std;

const auto MAXN = 50000u;
using snow_t = unsigned;

struct edge
{
	unsigned vertex;
	snow_t crit;

	edge (unsigned a, snow_t b) : vertex (a), crit (b)
	{ }
};

vector < edge > ln [MAXN];
bool visited [MAXN];

bool connected (unsigned n, unsigned ignore, snow_t snow)
{
	for (auto& x : visited) x = false;
	if (ignore != -1)
		visited [ignore] = true;

	queue < unsigned > q;
	for (unsigned i = 0 ; i < n ; i ++)
		if (not visited [i])
		{
			q.push (i);
			break;
		}
	while (!q.empty ())
	{
		auto front = q.front (); q.pop ();

		for (auto& neib : ln [front])
			if (neib.crit > snow and not visited [neib.vertex])
			{
				q.push (neib.vertex);
				visited [neib.vertex] = true;
			}
	}
	for (unsigned i = 0 ; i < n ; i ++)
		if (not visited [i])
			return false;
	return true;
}

unsigned danger (unsigned n, snow_t snow)
{
	if (not connected (n, -1, snow))
		return 0;

	unsigned dangerous = 0;
	for (unsigned blocked = 0 ; blocked < n ; blocked ++)
		dangerous += !connected (n, blocked, snow);
	return dangerous;
}

void print (unsigned n, snow_t snow)
{
	cout << snow << " ";
	vector < unsigned > ans;

	unsigned dangerous = 0;
	for (unsigned blocked = 0 ; blocked < n ; blocked ++)
		if (!connected (n, blocked, snow))
			ans.push_back (blocked + 1);
	cout << ans.size () << "\n";
	cout << ans [0];
	for (unsigned i = 1 ; i < ans.size () ; i ++)
		cout << " " << ans [i];
	cout << endl;
}

unsigned answer (unsigned n, unsigned k, snow_t min_snow, snow_t max_snow, int variant = 0)
{
	snow_t Min = min_snow, Max = max_snow;

	bool equaltok = false;
	bool betterthank = false;

	while (Min + 1 < Max)
	{
		snow_t mid = (Min + Max) / 2;
		//cout << Min << " " << Max << endl;
		//cout << "snow: " << mid << " crit cities: ";
		auto dangers_curr = danger (n, mid);
		//cout << dangers_curr << endl;
		//cout << "snow: " << mid + 1 << " crit cities: ";
		auto dangers_next = danger (n, mid + 1);
		//cout << dangers_next << endl;
		if (dangers_curr == 0 and dangers_next == 0)
		{
			if (variant and not equaltok and not betterthank)
				Max = mid;
			else 
				Min = mid + 1;
		}
		else if (dangers_curr == 0 and dangers_next > 0)
		{
			Min = mid + 1;
		}
		else if (0 < dangers_curr and dangers_curr < k and 0 < dangers_next and dangers_next < k)
		{
			Min = mid + 1;
		}
		else if (0 < dangers_curr and dangers_curr < k and dangers_next >= k)
		{
			//cout << "return "  << mid + 1 << endl;
			return mid + 1;
		}
		else if (dangers_curr > k and dangers_next == 0)
		{
			Max = mid;
			betterthank = true;
		}
		else if (dangers_curr > k and dangers_next > k)
		{
			Max = mid;
			betterthank = true;
		}
		else if (dangers_curr == k and dangers_next == k)
		{
			Max = mid;
			equaltok = true;
		}
		else if (dangers_curr == k and dangers_next == 0)
		{
			Max = mid;
			equaltok = true;
		}
	}
	//cout << "exit" << endl;
	if (not equaltok and not betterthank)
		return -1;
	//cout << danger (n, Max) << endl;
	return Max;
}

int main ()
{
	cin.tie (nullptr);
	ios::sync_with_stdio (false);

	unsigned n, m, k;
	cin >> n >> m >> k;

	snow_t max_crit = 0;
	snow_t min_crit = 0;

	for (unsigned i = 0 ; i < m ; i ++)
	{
		unsigned a, b; snow_t crit;
		cin >> a >> b >> crit;
		a --;
		b --;
		max_crit = max (max_crit, crit);
		min_crit = min (min_crit, crit);
		ln [a].push_back (edge (b, crit));
		ln [b].push_back (edge (a, crit));
	}

	//for (int i = 0 ; i <= 19 ; i ++)
	//	cout << i << " " << danger (n, i) << endl;
	unsigned ans1 = answer (n, k, min_crit, max_crit, 1);
	if (ans1 != -1)
		max_crit = ans1;
	unsigned ans2 = answer (n, k, min_crit, max_crit);

	//cout << ans1 << " " << ans2 << endl;
	if (ans1 == -1 and ans2 == -1)
		cout << -1 << " " << 0 << endl;
	else if (ans1 == -1)
		print (n, ans2);
	else if (ans2 == -1)
		print (n, ans1);
	else
		print (n, min (ans1, ans2));
}
