#include<iostream>
#include<vector>
using namespace std;
int B;
int to_int(char c)
{
    if(c >= '0' && c <= '9')    return c - '0';
    return c - 'A' + 10;
}
char to_char(int c)
{
    if(c >= 0 && c <= 9)    return c + '0';
    return c + 'A' - 10;
}
vector<int> add(vector<int> a, vector<int> b, int &pr)
{
    vector<int> ans;
    for(int i = 0; i < a.size(); i ++)
    {
        ans.push_back(a[i]);
    }
    for(int i = a.size() - 1; i >= 0; i --)
    {
        ans[i] += b[i] + pr;
        pr = ans[i] / B;
        ans[i] %= B;
    }
    return ans;
}
void print_vec(vector<int> a)
{
    for(int i = 0; i < a.size(); i ++)
    {
        cout << to_char(a[i]);
    }
}
void normalize_period(vector<int> &a)
{
    vector<int> na;
    for(int i = 0; i < a.size(); i ++)
    {
        na.push_back(a[i]);
        for(int j = i + 1; j < a.size(); j ++)
        {
            if(a[j] != na[(j) % (i + 1)])  break;
            if(j == a.size() - 1)
            {
                a = na;
                return ;
            }
        }
    }
}
struct num
{
    vector<int> I;
    vector<int> F;
    vector<int> P;
    long long a, b;
    num(string s = "")
    {
        int i;
        for(i = 0; i < s.size() && s[i] != '.'; i ++)
        {
            if(!(I.empty() && s[i] == '0'))
            {
                I.push_back(to_int(s[i]));
            }
        }
        for(i ++; i < s.size() && s[i] != '('; i ++)
        {
            F.push_back(to_int(s[i]));
        }
        for(i ++; i < s.size() && s[i] != ')'; i ++)
        {
            P.push_back(to_int(s[i]));
        }
        normalize_period(P);
    }
    void print()
    {
        for(int i = 0; i < I.size(); i ++)
        {
            cout << to_char(I[i]);
        }
        cout << ".";
        for(int i = 0; i < F.size(); i ++)
        {
            cout << to_char(F[i]);
        }
        cout << "(";
        for(int i = 0; i < P.size(); i ++)
        {
            cout << to_char(P[i]);
        }
        cout << ")";
    }
    void roll_period(int n)
    {
        if(n == 1)  return;
        vector<int> nP;
        for(int i = n % P.size(); i != (P.size() - 1 + n) % P.size(); i = (i + 1) % P.size())
        {
            nP.push_back(P[i]);
        }
        nP.push_back(P[(P.size() - 1 + n) % P.size()]);
        P = nP;
    }
    void extend_f(int n)
    {
        int i, j = F.size();
        for(i = 0; i < n - j; i ++)
        {
            F.push_back(P[i % P.size()]);
        }
        roll_period(i);
    }
};
vector<int> add_period(vector<int> a, vector<int> b, int &pr)
{
    int n = a.size() * b.size();
    int sa = a.size(), sb = b.size();
    for(int i = sa; i < n; i ++)  a.push_back(a[i % sa]);
    for(int i = sb; i < n; i ++)  b.push_back(b[i % sb]);
    pr = 0;
    vector<int> ans = add(a, b, pr);
    bool only9 = true;
    for(int i = 0; i < ans.size(); i ++)
    {
        if(ans[i] != B - 1) only9 = false;
    }
    if(only9)
    {
        ans.clear();
        pr = 1;
        return ans;
    }
    if(pr == 1)
    {
        ans = add(a, b, pr);
        /*cout << "hi";
        print_vec(a);
        cout << " ";
        print_vec(b);
        cout << " ";
        print_vec(ans);
        cout << "/\n";*/
        only9 = true;
        for(int i = 0; i < ans.size(); i ++)
        {
            if(ans[i] != B - 1) only9 = false;
        }
        if(only9)
        {
            ans.clear();
            pr = 1;
            return ans;
        }
    }
    return ans;
}
int main()
{
    cin >> B;
    string s1, s2;
    cin >> s1 >> s2;
    num a1(s1), a2(s2);
    int nf = max(a1.F.size(), a2.F.size());
    a1.extend_f(nf);
    a2.extend_f(nf);
    int pr = 0;
    vector<int> aP = add_period(a1.P, a2.P, pr);
    vector<int> aF = add(a1.F, a2.F, pr);
    int ni = max(a1.I.size(), a2.I.size());
    vector<int> I1, I2;
    for(int i = 0; i < ni - a1.I.size(); i++)   I1.push_back(0);
    for(int i = 0; i < ni - a2.I.size(); i++)   I2.push_back(0);
    for(int i = 0; i < a1.I.size(); i++)   I1.push_back(a1.I[i]);
    for(int i = 0; i < a2.I.size(); i++)   I2.push_back(a2.I[i]);
    vector<int> aI = add(I1, I2, pr);

    if(aP.size() == 0)
    {
        int end0 = 0;
        for(int i = aF.size() - 1; i >= 0; i --)
        {
            if(aF[i] != 0)  break;
            end0 ++;
        }
        vector<int> naf;
        for(int i = 0; i < aF.size() - end0; i ++)
        {
            naf.push_back(aF[i]);
        }
        aF = naf;
    }


    normalize_period(aP);
    if(pr != 0) cout << pr;
    print_vec(aI);
    if(!(aF.size() == 0 && aP.size() == 0))
        cout << ".";
    if(!aF.size() == 0)  print_vec(aF);
    if(aP.size() > 0)
    {
        cout << "(";
        print_vec(aP);
        cout << ")";
    }

}
/*
5
1242.11(2)
002.1322(22)
*/
