#include <bits/stdc++.h>
using namespace std;
#define _ << " " <<
#define debug(x) #x << " = " << (x)

#define X first
#define Y second

#define ll long long
#define ull unsigned long long

using pii = std::pair<int, int>;
using pll = std::pair<ll, ll>;


const int maxn = 5e4+100;
vector<pii> v[maxn];

void add_edge(int x, int y, int c)
{
    v[x].push_back({y, c});
    v[y].push_back({x, c});
}

static int _gl_time = 0;
static int articulated = 0;
int disc[maxn], low[maxn];
int viz[maxn], mark[maxn];

void reset()
{
    _gl_time = 1;
    articulated = 0;
    memset(disc, 0, sizeof(disc));
    memset(low, 0, sizeof(low));
    memset(viz, 0, sizeof(viz));
    memset(mark, 0, sizeof(mark));
}


int count_reachable(int x, int max)
{
    if (viz[x])
        return 0;

    viz[x] = 1;
//    std::cout << debug(x) << std::endl;
    int count = 1;
    for (auto e : v[x])
        if (e.Y > max)
        {
            count += count_reachable(e.X, max);
        } else
        {
 //           std::cout << "blocked " _ debug(x) _ debug(e.X) << std::endl;
        }
    
    return count;
}

void find_articulation(int x, int max, int par = -1)
{
    if (disc[x] > 0) return;

    disc[x] = low[x] = _gl_time++;
   // cout << debug(x) _ debug(max) << std::endl;

    int neigh1 = -1, neigh2 = -1;

    int m_articulation = 0;
    for (auto e : v[x])
    {
        if (e.Y > max)
        {
            if (neigh1 == -1) neigh1 = e.X;
            else if (neigh1 != e.X) neigh2 = e.X;
        }

        if (e.Y > max && e.X != par)
        {
            find_articulation(e.X, max, x);
  //          std::cout << debug(x) _ debug(disc[x]) _ debug(e.X) _ debug(low[e.X]) << std::endl;

            if (low[e.X] > disc[x] or (low[e.X] == disc[x] && par != -1))
                m_articulation = 1;
            else
            {
                low[x] = std::min(low[x], low[e.X]);
            }
        }
    }

    if (neigh2 == -1) m_articulation = 0;
 //   if (m_articulation) cout << debug(x) _ debug(neigh1) _ debug(neigh2) _ debug(max) << endl;
  //  cout << debug(x) _ debug(m_articulation) << endl;
   // if (par == -1) m_articulation = 0;
    mark[x] = m_articulation;
    articulated += m_articulation;
}


int main()
{
    std::ios::sync_with_stdio(false);

    int n, m, k;
    cin >> n >> m >> k;

    int max = 0;
    for (int i = 0; i < m; i++)
    {
        int x, y, w;
        cin >> x >> y >> w;

        if (x == y) continue;
        add_edge(x, y, w);
        max = std::max(max, w);
    }

    if (count_reachable(1, 0) < n)
    {
        cout << -1 _ 0 << endl;
        return 0;
    }

    int l = 0, r = max + 1;

    while(r - l > 1)
    {
        int mid = (l + r) / 2;

        reset();

        int ans = count_reachable(1, mid);
       // cout << debug(mid) _ debug(ans) << std::endl;
        if (ans == n)
        {   
            l = mid;
        } else
        {
            r = mid;
        }
    }


    int s = -1, e = l;

   // std::cout << debug(s) _ debug(e) << std::endl;

    reset();
    find_articulation(1, l);

    //std::cout << debug(articulated) << std::endl;
    if (articulated < k)
    {
        cout << -1 _ 0 << endl;
        return 0;
    }

    while(e - s > 1)
    {
        int mid = (e + s) / 2;
        reset();

        find_articulation(1, mid);

    //    std::cout << debug(mid) _ debug(articulated) << std::endl;

        if (articulated >= k)
        {
            e = mid;
        } else
        {
            s = mid;
        }
   //     break;
    }

    std::cout << e << " " << articulated << endl;
    for (int i = 1; i <= n; i++)
        if (mark[i]) std::cout << i << " ";
    std::cout << endl;

    return 0;
}


