#include <bits/stdc++.h>
using namespace std;
#define _ << " " <<
#define debug(x) #x << " = " << (x)


#define ll long long
#define ull unsigned long long

using pii = std::pair<int, int>;
using pll = std::pair<ll, ll>;

using bi = std::string;

void bail()
{
    int *p = 0;

    *p =1;
}

int k = 0;

int fromchar(char c)
{
    if ('0' <= c && c <= '9')
        return c - '0';
    else
        return 10 + c - 'A';
}

char tochar(int i)
{
    if (i < 10)
        return '0' + i;
    else
        return 'A' + i - 10;
}

bi sum(bi a, bi b)
{
    int i = a.length() - 1, j = b.length() - 1;

    bi res;
    int carry = 0;
    while (i >= 0 && j >= 0)
    {
        int c1 = fromchar(a[i]), c2 = fromchar(b[j]);
        int m = c1 + c2 + carry;
        carry = m / k;
        m %= k;

        res += tochar(m);
        --i; --j;
    }

    while (i >= 0)
    {
        int c1 = fromchar(a[i]);
        int m = c1 + carry;
        carry = m / k;
        m %= k;

        res += tochar(m);
        --i;
    }
    while (j >= 0)
    {
        int c2 = fromchar(b[j]);
        int m = c2 + carry;
        carry = m / k;
        m %= k;

        res += tochar(m);
        --j;
    }

    if (carry > 0)
        res += tochar(carry);

    reverse(res.begin(), res.end());
    return res;
}

bi sub(bi a, bi b)
{
    int i = a.length() - 1, j = b.length() - 1;

    bi res;
    int carry = 0;
    while (i >= 0 && j >= 0)
    {
        int c1 = fromchar(a[i]), c2 = fromchar(b[j]);
        int m = c1 - c2 + carry;
        if (m < 0) m += k, carry = -1;
        else carry = 0;

        m %= k;

        res += tochar(m);
        --i; --j;
    }

    while (i >= 0)
    {
        int c1 = fromchar(a[i]);
        int m = c1 + carry;

        if (m < 0) m += k, carry = -1;
        else carry = 0;

        m %= k;

        res += tochar(m);
        --i;
    }

    while(res.size() && res.back() == '0') res.pop_back();
    reverse(res.begin(), res.end());

    return res;
}

struct number
{
    bi normal;
    bi period;

    int dot;
};

istream& operator >> (istream& in, number& n)
{
    bi line;
    in >> line;

    //std::cout << line << std::endl;

    size_t dot = line.find_first_of('.');
    size_t period = line.find_first_of('(');

    if (dot == string::npos)
    {
        n.normal = line;
        n.period = "0";
        n.dot = 0;

        return in;
    }

    n.normal = line.substr(0, dot);
    if (period == string::npos)
    {
        n.normal += line.substr(dot + 1);
        n.period = "0";
        n.dot = line.length() - dot - 1;
    } else
    {
        n.normal += line.substr(dot + 1, period - dot - 1);
        n.period = line.substr(period + 1);
        n.period.pop_back(); // remove ')'

        n.dot = period - dot - 1;
    }

    return in;
}

void rotate_period(number& a, int count)
{
    bi per = a.period;

    for (size_t i = 0; i < a.period.size(); i++)
    {
        a.period[i] = per[(i + count) % a.period.size()];
    }
}

void extend(number& a, int target)
{
    int add = 0;
    while(a.dot < target)
    {
        a.normal.push_back(a.period[add % a.period.size()]);
        a.dot++;
        add++;
    }

    rotate_period(a, add);
}

bi generate(int n)
{
    std::string r;

    char c = tochar(k - 1);
    while(n--) r.push_back(c);
    return r;
}

number sum(number& a, number &b)
{
    int ndot = std::max(a.dot, b.dot);
    extend(a, ndot);
    extend(b, ndot);

 //   std::cout << debug(a.normal) _ debug(b.normal) << std::endl;

    number result;
    result.normal = sum(a.normal, b.normal);
    result.dot = ndot;

    /* now sum periods */
    int alen = a.period.length(), blen = b.period.length();
    int tar = alen * blen / __gcd(alen, blen);

//    std::cout << debug(tar) << std::endl;

    string base_a = a.period;
    string base_b = b.period;

    while(a.period.length() < tar)
        a.period += base_a;
    while(b.period.length() < tar)
        b.period += base_b;

    result.period = sum(a.period, b.period);

    int plen = result.period.length();
    if (plen > tar)
    {
        result.period = sub(result.period, generate(tar));
        result.normal = sum(result.normal, "1");
    }

    plen = result.period.length();
    for (int i = 1; i <= plen / 2; i++)
    {
        if (plen % i == 0)
        {
            bool ok = true;
            for (int j = 0; j < plen; j++)
                ok = ok && result.period[j % i] == result.period[j];
            if (ok)
            {
                result.period = result.period.substr(0, i);
                break;
            } }
    }

    if (result.period.length() == 1 && result.period[0] == tochar(k - 1))
    {
        result.normal = sum(result.normal, "1");
        result.period = "0";
    }

    int pptr = result.period.length() - 1;
    int p = result.normal.length() - 1;
    int taken = 0;

   // cout << pptr _ p _ debug(result.period[pptr]) _ debug(result.normal[p]) _ debug(result.dot) << endl;
    while(taken < result.dot && result.period[pptr] == result.normal[p])
    {
        pptr = pptr - 1;
        if (pptr == -1)
            pptr += result.period.length();
        --p;
        ++taken;
    }

    int test = taken % result.period.size();
    test = ((int)result.period.size() - test);
    rotate_period(result, test);

    result.dot -= taken;
    while(taken--) result.normal.pop_back();

    while(result.normal.front() == '0')
        result.normal.erase(result.normal.begin());

    return result;
}

int main()
{
    std::ios::sync_with_stdio(false);
    cin >> k;

    cin.ignore();
    number a, b;
    cin >> a >> b;

   // std::cout << debug(a.normal) _ debug(a.period) _ debug(a.dot) << debug(b.normal) _ debug(b.period) _ debug(b.dot) << std::endl;

    number c = sum(a, b);

    if (c.dot == 0 && c.period == "0")
    {
        std::cout << c.normal << std::endl;
    } else
    {
        int len = c.normal.length();
        std::cout << c.normal.substr(0, len - c.dot);
        std::cout << "."; std::cout << c.normal.substr(len - c.dot); 
        if (c.period != "0")
        {
            bail();
        
        std::cout << "(" << c.period << ")" << std::endl;
    }
        else
            cout << endl;
    }

    return 0;
}
