#include <bits/stdc++.h>
using namespace std;
#define _ << " " <<
#define debug(x) #x << " = " << (x)

#define X first
#define Y second

#define ll long long
#define ull unsigned long long

using pii = std::pair<int, int>;
using pll = std::pair<ll, ll>;


const int maxn = 5e4+100;
vector<pii> v[maxn];

void add_edge(int x, int y, int c)
{
    v[x].push_back({y, c});
    v[y].push_back({x, c});
}

static int _gl_time = 0;
static int articulated = 0;
int disc[maxn], low[maxn];
int viz[maxn], mark[maxn];
int ans[maxn];

void reset()
{
    _gl_time = 1;
    memset(disc, 0, sizeof(disc));
    memset(low, 0, sizeof(low));
    memset(viz, 0, sizeof(viz));
}


int count_reachable(int x, int max)
{
    if (viz[x])
        return 0;

    viz[x] = 1;
//    std::cout << debug(x) << std::endl;
    int count = 1;
    for (auto e : v[x])
        if (e.Y > max && !mark[e.X])
        {
            count += count_reachable(e.X, max);
        } else
        {
           // std::cout << "blocked " _ debug(x) _ debug(e.X) << std::endl;
        }
    
    return count;
}

void find_articulation(int n, int max)
{
    articulated = 0;
    memset(ans, 0, sizeof(ans));

    for (int i = 1; i <= n; i++)
    {

        reset();


        int k = i + 1;
        if (i == n) k = 1;

        mark[i] = 1;
        //cout << "block " _ debug(i) << endl;

        if (count_reachable(k, max) < n - 1)
            ans[i] = 1, articulated++;

        mark[i] = 0;
    }
}


int main()
{
    std::ios::sync_with_stdio(false);

    int n, m, k;
    cin >> n >> m >> k;
    std::vector<int> possible;

    int max = 0;
    for (int i = 0; i < m; i++)
    {
        int x, y, w;
        cin >> x >> y >> w;

        add_edge(x, y, w);
        max = std::max(max, w);
        possible.push_back(w);
    }
    std::sort(possible.begin(), possible.end());

    for (int i : possible)
    {
        reset();
        if (count_reachable(1, i) < n)
        {
            std::cout << -1 _ 0 << std::endl;
            return 0;
        }

        find_articulation(n, i);
        if (articulated >= k)
        {
            std::cout << i _ articulated << std::endl;
            for (int i = 1; i <= n; i++)
                if (ans[i]) std::cout << i << " ";
            std::cout << endl;
            return 0;
        }
    }
    return 0;

    if (count_reachable(1, 0) < n)
    {
        cout << -1 _ 0 << endl;
        return 0;
    }

    int l = 0, r = max;

    while(r - l > 1)
    {
        int mid = (l + r) / 2;

        reset();

        int ans = count_reachable(1, mid);
       // cout << debug(mid) _ debug(ans) << std::endl;
        if (ans == n)
        {   
            l = mid;
        } else
        {
            r = mid;
        }
    }


    int s = -1, e = l;

   // std::cout << debug(s) _ debug(e) << std::endl;

    reset();
    find_articulation(n, l);

    //std::cout << debug(articulated) << std::endl;
    if (articulated < k)
    {
        cout << -1 _ 0 << endl;
        return 0;
    }

    while(e - s > 1)
    {
        int mid = (e + s) / 2;
        reset();

        find_articulation(n, mid);

    //    std::cout << debug(mid) _ debug(articulated) << std::endl;

        if (articulated >= k)
        {
            e = mid;
        } else
        {
            s = mid;
        }
   //     break;
    }

  //  std::cout << "JJJJJJJJJJJJJJJ" << std::endl;
   // find_articulation(n, e);
    std::cout << e << " " << articulated << endl;
    for (int i = 1; i <= n; i++)
        if (ans[i]) std::cout << i << " ";
    std::cout << endl;

    return 0;
}


