#include <iostream>
#include <string>
using namespace std;

const int LEN = 500;

int b;
string x1, x2, y1, y2;

int value(char c)
{
    if ('0' <= c and c <= '9') return c - '0';
    else return c - 'A';
}

int symbol(int x)
{
    if (x < 10) return '0' + x;
    else return 'A' + x - 10;
}

pair<string, int> sumd(string x, string y)
{
    int p = 1, s = 0;
    for (int i = x.size() - 1; i >= 0; -- i)
    {
        s = value(x[i]) + value(y[i]) + p;
        p = s / b;
        s = s % b;
        x[i] = symbol(s);
    }
    return make_pair(x, p);
}

string sumc(string x, string y, int p)
{
    int s = 0;
    for (int i = x.size() - 1; i >= 0; -- i)
    {
        s = value(x[i]) + value(y[i]) + p;
        p = s / b;
        s = s % b;
        x[i] = symbol(s);
    }
    if (p != 0) x = "1" + x;
    return x;
}

void prepare(string s, int which)
{
     while (s[0] == '0') s.erase(s.begin());
     int p1 = -1, p2 = -1;
     for (int i = 0; i < s.size(); ++ i)
     {
         if (s[i] == '(') p1 = i;
         if (s[i] == ')') p2 = i;
     }
     string p = "";
     for (int i = p1 + 1; i < p2; ++ i)
     {
         p += s[i];
     }
     if (p.size() == 0) p = "0";

     if (p1 != -1 or p2 != -1)
     {
         char last;
         do
         {
             last = s.back();
             s.erase(--s.end());
         }
         while (last != '(');
     }

     string d = "";
     bool point = false;
     for (int i = 0; i < s.size(); ++ i)
     {
         if (point) d += s[i];
         if (s[i] == '.') point = true;
     }

     if (point)
     {
         char last;
         do
         {
             last = s.back();
             s.erase(--s.end());
         }
         while (last != '.');
     }

    while (d.size() + p.size() <= LEN)
    {
        d += p;
    }
    for (int i = 0; i < p.size(); ++ i)
    {
        if (d.size() == LEN) break;
        else d += p[i];
    }

    if (which == 0)
    {
        x1 = s;
        x2 = d;
    }
    else
    {
        y1 = s;
        y2 = d;
    }
}

string format(string s)
{
    string d = "";
    for (int i = 1; i <= s.size(); ++ i)
    {
        for (int j = 0; j < s.size() / 4; ++ j)
        {
            bool ok = true;
            for (int k = j; k < s.size() / 2; ++ k)
            {
                if (s[k] != s[j + (k - j) % i])
                {
                    ok = false;
                    break;
                }
            }

            if (ok)
            {
                for (int k = 0; k < j; ++ k)
                {
                    d += s[k];
                }
                d += "(";
                for (int k = j; k < j + i; ++ k)
                {
                    d += s[k];
                }
                d += ")";
                return d;
            }
        }
    }
    return s;
}

void Init()
{
    string s1, s2;
    cin >> b >> s1 >> s2;

    prepare(s1, 0);
    prepare(s2, 1);

    while (x1.size() < y1.size()) x1 = "0" + x1;
    while (x1.size() > y1.size()) y1 = "0" + y1;

    /*cout << x1 << ' ' << x2 << endl;
    cout << y1 << ' ' << y2 << endl;*/
}


int main()
{
    Init();

    auto d = sumd(x2, y2);
    string c = sumc(x1, y1, d.second);


    bool special = true;
    for (int i = 0; i < LEN / 2; ++ i)
    {
        if (d.first[i] != '0')
        {
            special = false;
            break;
        }
    }
    if (special)
    {
        cout << c << endl;
        return 0;
    }

    cout << c  << '.' << format(d.first) << endl;

}


/*
5
1242.1(2)
002.322(22)
*/
