#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#define fi first
#define se second
using namespace std;

const int MAXN = 50005;
const int MAXM = 200005;

int n, m, k;
vector<pair<int, int>> g[MAXN];

int snow = 0;
vector<int> v, e;

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int u, v, s;

    cin >> n >> m >> k;
    for (int i = 1; i <= m; ++ i)
    {
        cin >> u >> v >> s;
        e.push_back(s);
        g[u].emplace_back(v, s);
        g[v].emplace_back(u, s);
    }
}

int t, vis[MAXN], opt[MAXN], par[MAXN], sub[MAXN], non[MAXN];

void toZero()
{
    t = 0;
    for (int i = 0; i < MAXN; ++ i)
    {
        non[i] = vis[i] = par[i] = 0;
        sub[i] = opt[i] = MAXN;
    }
}

void DFS(int u)
{
    // cout << "start: " << u << endl;
    vis[u] = opt[u] = sub[u] = ++ t;
    for (auto v : g[u])
    {
        // cout << "road: " << u << ' ' << v.fi << endl;
        if (v.se <= snow) continue;
        if (vis[v.fi] == 0)
        {
            par[v.fi] = u;
            DFS(v.fi);
            non[u]++;
            sub[u] = min(sub[u], opt[v.fi]);
            sub[u] = min(sub[u], sub[v.fi]);
        }
        if (v.fi != par[u]) opt[u] = min(opt[u], opt[v.fi]);
    }
    opt[u] = max(opt[u], sub[u]);
    // cout << "exit: " << u << ' ' << vis[u] << ' ' << opt[u] << ' ' << sub[u] << endl;
}

int Count()
{
    int cnt = 0;
    for (int i = 1; i <= n; ++ i)
    {
        if (vis[i] == 0) return -1;
        if (vis[i] <= sub[i] and non[i] != 0) cnt++;
    }
    if (non[1] == 1) cnt--;
    return cnt;
}

void Print()
{
    if (non[1] != 1) cout << 1;
    for (int i = 2; i <= n; ++ i)
    {
        if (vis[i] <= sub[i] and non[i] != 0) cout << ' ' << i;
    }
    cout << endl;
}

int main()
{
    Init();

    sort(e.begin(), e.end());

    int cnt;
    for (int i = 0; i < e.size(); ++ i)
    {
        if (snow == e[i]) continue;
        else
        {
            snow = e[i];
            toZero();
            DFS(1);
        }

        cnt = Count();
        if (cnt == -1)
        {
            cout << -1 << ' ' << 0 << endl;
            return 0;
        }
        if (cnt >= k)
        {
            break;
        }
    }

    cout << snow << ' ' << cnt << endl;
    Print();

    return 0;
}

/*
8 13 3
1 2 19
1 3 13
2 3 5
4 2 9
2 5 7
3 5 17
6 3 8
3 8 12
4 7 11
5 7 5
7 2 10
7 6 13
8 5 16
----------
3 3 1
1 2 42
2 3 42
1 3 666
*/
