#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

int base;
string s, t, sI, sF, sP, tI, tF, tP;
string sX, sY, tX, tY, ansX, ansY, ans;
unordered_map< string, int > pastReminders;

void NormalizeI(string &I) {
	int ind = 0;
	while(ind < (int) I.size() && I[ind] == '0') {
		ind++;
	}

	if(ind == (int) I.size()) {
		ind--;
	}

	I = I.substr(ind);
}

void NormalizeP(string &P) {
	for(int i = 1; i <= (int) P.size(); i++) {
		if(P.size() % i != 0) {
			continue;
		}

		bool isOk = true;
		for(int j = i; j < (int) P.size(); j++) {
			if(P[j] != P[j - i]) {
				isOk = false;
				break;
			}
		}

		if(isOk) {
			P = P.substr(0, i);
			break;
		}
	}
}

void NormalizeF(string &F, const string &P) {
	int len = (int) F.size();
	for(int i = (int) F.size() - P.size(); i >= 0; i -= P.size()) {
		if(F.substr(i, P.size()) == P) {
			len -= P.size();
		}
	}

	F = F.substr(0, len);
}

void Normalize(string &s, string &I, string &F, string &P) {
	bool isInI = true, isInF = false;
	for(int i = 0; i < (int) s.size(); i++) {
		if(s[i] == '.') {
			isInI = false;
			isInF = true;
			continue;
		}

		if(s[i] == '(') {
			isInF = false;
			continue;
		}

		if(s[i] == ')') {
			break;
		}

		if(isInI) {
			I += s[i];
		}
		else if(isInF) {
			F += s[i];
		}
		else {
			P += s[i];
		}
	}

	if(P.size() == 0) {
        if(F.size() == 0) {
            F = "0";
        }
        P = "0";
	}

	NormalizeI(I);
	NormalizeP(P);
	if(F.size() != 0) {
        NormalizeF(F, P);
	}
}

int GetDigit(char c) {
	if(c >= '0' && c <= '9') {
		return (int) (c - '0');
	}
	else {
		return (int) (c - 'A' + 10);
	}
}

char GetSymbol(int x) {
	if(x < 10) {
		return (char) (x + '0');
	}
	else {
		return (char) (x - 10 + 'A');
	}
}

void Subtract(const string &x, const string &y, string &res) {
	int indInX = (int) x.size() - 1;
	int indInY = (int) y.size() - 1;

	int aux = 0;
	while(indInY >= 0) {
		int curr = GetDigit(x[indInX]) - aux - GetDigit(y[indInY]);
		if(curr < 0) {
			curr += base;
			aux = 1;
		}
		else {
			aux = 0;
		}

		res += GetSymbol(curr);

		indInX--;
		indInY--;
	}

	while(indInX >= 0) {
		int curr = GetDigit(x[indInX]) - aux;

		if(curr < 0) {
			curr += base;
			aux = 1;
		}
		else {
			aux = 0;
		}

		res += GetSymbol(curr);

		indInX--;
	}

	reverse(res.begin(), res.end());

	int ind = 0;
	while(ind < (int) res.size() && res[ind] == '0') {
		ind++;
	}

	if(ind == (int) res.size()) {
		ind--;
	}
	res = res.substr(ind);
}

void FindFraction(const string &I, const string &F, const string &P, string &X, string &Y) {
	string aux1 = I + F + P, aux2 = I + F;

	Subtract(aux1, aux2, X);

	string aux3 = "1", aux4 = "1";
	for(int i = 1; i <= (int) aux1.size() - (int) I.size(); i++) {
		aux3 += '0';
	}

	for(int i = 1; i <= (int) aux2.size() - (int) I.size(); i++) {
		aux4 += '0';
	}

	Subtract(aux3, aux4, Y);
}

void Add(const string &x, const string &y, string &res) {
	int indInX = (int) x.size() - 1;
	int indInY = (int) y.size() - 1;

	int aux = 0;
	while(indInY >= 0) {
		int curr = GetDigit(x[indInX]) + aux + GetDigit(y[indInY]);
		if(curr >= base) {
			curr -= base;
			aux = 1;
		}
		else {
			aux = 0;
		}

		res += GetSymbol(curr);

		indInX--;
		indInY--;
	}

	while(indInX >= 0) {
		int curr = GetDigit(x[indInX]) + aux;

		if(curr >= base) {
			curr -= base;
			aux = 1;
		}
		else {
			aux = 0;
		}

		res += GetSymbol(curr);

		indInX--;
	}

	if(aux != 0) {
        res += '1';
	}

	reverse(res.begin(), res.end());
}

void Multiply(const string &x, const string &y, string &res) {
    res.resize((int) x.size() + (int) y.size() + 1, '0');

    int aux1 = res.size() - 1;
    for(int i = (int) x.size() - 1; i >= 0; i--) {
        int aux2 = aux1, aux = 0;
        for(int j = (int) y.size() - 1; j >= 0; j--) {
            int curr = GetDigit(x[i]) * GetDigit(y[j]) + aux + (int) (res[aux2] - '0');

            if(curr >= base) {
                aux = curr / base;
                curr %= base;
            }
            else {
                aux = 0;
            }

            res[aux2] = GetSymbol(curr);

            aux2--;
        }

        if(aux != 0) {
            int curr = (int) (res[aux2] - '0') + aux;
            res[aux2] = GetSymbol(curr);
        }

        aux1--;
    }

    int ind = 0;
    while(ind < (int) res.size() && res[ind] == '0') {
        ind++;
    }

    if(ind == (int) res.size()) {
        ind--;
    }

    res = res.substr(ind);
}

void FindAnsFraction(const string &sX, const string &sY, const string &tX, const string &tY, string &ansX, string &ansY) {
    string aux1;
    Multiply(sX, tY, aux1);

    string aux2;
    Multiply(sY, tX, aux2);

    Add(aux1, aux2, ansX);
    Multiply(sY, tY, ansY);
}

bool IsSmaller(const string &x, const string &y) {
    if(x.size() < y.size()) {
        return true;
    }
    else if(x.size() > y.size()) {
        return false;
    }
    else {
        return x < y;
    }
}

void CleanPrefixZeros(string &x) {
    int ind = 0;
    while(ind < (int) x.size() && x[ind] == '0') {
        ind++;
    }

    if(ind == (int) x.size()) {
        ind--;
    }

    x = x.substr(ind);
}

void FindAns(const string &X, const string &Y) {
    int ind = 0;
    string aux = "";

    while(IsSmaller(aux, Y)) {
        aux += X[ind];
        ind++;
    }

    string ansI = "";
    while(1) {
        CleanPrefixZeros(aux);

        int curr = 0;
        while(!IsSmaller(aux, Y)) {
            string newAux;
            Subtract(aux, Y, newAux);
            aux = newAux;
            curr++;
        }

        ansI += GetSymbol(curr);

        if(ind == X.size()) {
            break;
        }
        aux += X[ind];
        ind++;
    }

    if(aux == "0") {
        ans = ansI;
        return;
    }

    string ansFP = "";

    pastReminders[aux] = 0;
    aux += "0";
    while(1) {
        int curr = 0;
        while(!IsSmaller(aux, Y)) {
            string newAux;
            Subtract(aux, Y, newAux);
            aux = newAux;
            curr++;
        }
        ansFP += GetSymbol(curr);

        if(aux == "0") {
            break;
        }

        if(pastReminders.count(aux) != 0) {
            ansFP.insert(ansFP.begin() + pastReminders[aux], '(');
            ansFP += ')';
            break;
        }

        pastReminders[aux] = ansFP.size();
        aux += '0';
    }

    ans = ansI + "." + ansFP;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cin >> base;
	cin >> s >> t;

	Normalize(s, sI, sF, sP);
	Normalize(t, tI, tF, tP);

	FindFraction(sI, sF, sP, sX, sY);
	FindFraction(tI, tF, tP, tX, tY);

	return 0;

	FindAnsFraction(sX, sY, tX, tY, ansX, ansY);
    FindAns(ansX, ansY);

    cout << ans << endl;
	return 0;
}
