#include <iostream>
#include <vector>
#include <math.h>
using namespace std;


struct DigitSum {
    int digit;
    int remainder;
};

void swapNums (int &a, int &b) {
    int temp = a;
    a = b;
    b = temp;
}

int LCM(int a, int b) {
    int oldA = a;
    int oldB = b;
    if (a < b) {
        swapNums(a, b);
    }
    int ggd;
    while (true) {
        a = a % b;
        if (a == 0) {
            ggd = b;
            break;
        }
        swapNums (a, b);
    }
    return oldA*oldB / ggd;
}

int digitValue (char digit) {
    if (digit >= '0' && digit <= '9') {
        return ((int)digit - (int)'0');
    } else if (digit >= 'A' && digit <= 'Z') {
        return ((int)digit - (int)'A' + 10);
    }
    else return -1;
}

char getDigit(int digit) {
    if (digit >= 0 && digit <= 9) {
        return (char)(digit + (int)'0');
    } else if (digit >= 10 && digit <= 35) {
        return (char)(digit + (int)'A' - 10);
    }
}

DigitSum sumDigits(int digit1, int digit2, int b) {
    DigitSum result;
    int sum = digit1 + digit2;
    if (sum >= b) {
        result.remainder = 1;
        sum = sum - b;
    } else {
        result.remainder = 0;
    }
    result.digit = sum;
    return result;
}

vector<int> makeIntDigits(string num) {
    vector<int> result;
    for (int i = 0; i < num.size(); i++) {
        result.push_back(digitValue(num[i]));
    }
    return result;
}

vector<int> makeNumber(vector<DigitSum> digits){
    vector<int> result;
    if (digits[0].remainder == 1) {
        result.push_back(-1);
    }

    for (int i = 0; i < digits.size() - 1; i++) {
        int sum = digits[i].digit + digits[i + 1].remainder;
        result.push_back(sum);
    }
    result.push_back(digits[digits.size() - 1].digit);
    return result;
}

string makeStringNumber(vector<int> number) {
    string result;
    int index = 0;
    if (number[0] == -1) {
        result = 'r';
        index = 1;
    }
    for (int i = index; i < number.size(); i++) {
        result += getDigit(number[i]);
    }
    //cout << result[0] << endl;
    return result;
}

vector<DigitSum> sumNums(vector<int> num1, vector<int> num2, int b) {
    vector<DigitSum> result;
    /*int minSize = num1.size();
    int maxSize = num2.size();
    if (num2.size() < minSize) {
        minSize = num2.size();
        maxSize = num1.size();
    }*/
    if (num2.size() > num1.size()) {
        vector<int> temp;
        temp = num1;
        num1 = num2;
        num2 = temp;
    }
    for (int i = 0; i < num1.size() - num2.size(); i++) {
        DigitSum digit;
        digit.digit = num1[i];
        digit.remainder = 0;
        result.push_back(digit);
    }
    for (int i = 0; i < num2.size(); i++) {
        DigitSum digit = sumDigits(num2[i], num1[num1.size() - num2.size() + i], b);
        result.push_back(digit);
    }
    return result;
}

string normalizePeriod (string period) {
    string result = "";
    vector<int> dividers;
    int halfPeriodSize = period.size() / 2;
    for (int i = 1; i <= halfPeriodSize; i++) {
        if (period.size() % i == 0) {
            dividers.push_back(i);
        }
    }
    cout << dividers[0] << endl;
    bool found = false;
    for (int i = 0; i < dividers.size(); i++) {
        bool isShortest = true;
        for (int j = 0; j < dividers[i]; j++) {
            bool flag = false;
            for (int k = j; j < period.size(); j += dividers[i]) {
                if (period[j] != period[k]) {
                    flag = true;
                    break;
                }
            }
            if (flag) {
                isShortest = false;
                break;
            }
        }
        if (isShortest) {
            found = true;
            for (int j = 0; j < dividers[i]; j++) {
                result += period[j];
            }
            break;
        }
    }
    if (!found) return period;
    return result;
}

string normalizeIntPart(string intPart) {
    string result = "";;
    int zeroCnt = 0;
    for (int i = 0; i < intPart.size(); i++) {
        if (intPart[i] == '0') {
            zeroCnt++;
        } else break;
    }
    for (int i = zeroCnt; i < intPart.size(); i++) {
        result += intPart[i];
    }
    return result;
}

string normalizeFinitePart(string finitePart, string &period) {
    string result = "";
    int cnt = 0;
    for (int i = finitePart.size() - 1; i >= 0; i --) {
        if (period[period.size() - 1 - ((finitePart.size() - 1 - i) % period.size())] == finitePart[i]) {
            cnt++;
            //cout << finitePart[i];
        } else break;
    }
    for (int i = 0; i < finitePart.size() - cnt; i++) {
        result += finitePart[i];
    }
    cnt = cnt % period.size();
    string newPeriod = "";
    for (int i = 0; i < period.size(); i++) {
        newPeriod += period[(period.size() - cnt + i) % period.size()];
    }
    period = newPeriod;
    return result;
}

string sumPeriods(string period1, string period2, int b) {
    string result = "";
    if (period1.size() < period2.size()) {
        string temp = period1;
        period1 = period2;
        period2 = temp;
    }

    string extPeriod1 = "";
    string extPeriod2 = "";
    int lcm = LCM (period1.size(), period2.size());
    for (int i = 0; i < lcm; i+= period1.size()) {
        extPeriod1 += period1;
    }
    for (int i = 0; i < lcm; i+= period2.size()) {
        extPeriod2 += period2;
    }
    extPeriod1 = extPeriod1 + extPeriod1;
    extPeriod2 = extPeriod2 + extPeriod2;
    vector<int> intPeriod1 = makeIntDigits(extPeriod1);
    vector<int> intPeriod2 = makeIntDigits(extPeriod2);
    string sum = makeStringNumber(makeNumber(sumNums(intPeriod1, intPeriod2, b)));
    if (sum[0] == 'r') {
        sum[0] = '1';
    }
    string newSum = "";
    for (int i = 0; i < lcm; i++) {
        newSum += sum[i];
    }
    result = normalizePeriod(newSum);
    return result;
}

string sumIntParts(string intPart1, string intPart2, int b) {
    string result;

    string sum = makeStringNumber(makeNumber(sumNums(makeIntDigits(intPart1), makeIntDigits(intPart2), b)));
    result = sum;
    return result;
}

int main ()
{
    /*int b;
    cin >> b;
    string num1, num2;
    cin >> num1 >> num2;*/
    DigitSum a = sumDigits(3,3,10);
    string period = "73";
    cout << sumIntParts("23", "31", 10);
    return 0;
}
