#include <stdio.h>
#include <string.h>
#define MAXN 1000
using namespace std;

int base;

char digitToSymbolInB(int d)
{
    if (d<10) return d+'0';
    return d-10+'A';
}

int NOD(int a, int b)
{
    int s;
    while (a!=b)
    {
        if (a<b)
        {
            s=a;
            a=b;
            b=s;
        }
        if (a%b==0) return b;
        a%=b;
    }
    return a;
}

int NOK(int a, int b)
{
    return (a*b)/NOD(a,b);
}

char sumTwoDigits(char a, char b, int carry)
{
    int resNum=carry;
    if (a>='0' && a<='9') resNum+=a-'0';
    else resNum+=10+a-'A';
    if (b>='0' && b<='9') resNum+=b-'0';
    else resNum+=10+b-'A';

    resNum%=base;
    if (resNum<10) return resNum+'0';
    return resNum-10+'A';
}

int carryFromSum(char a, char b, int carry)
{
    int resNum=carry;
    if (a>='0' && a<='9') resNum+=a-'0';
    else resNum+=10+a-'A';
    if (b>='0' && b<='9') resNum+=b-'0';
    else resNum+=10+b-'A';

    return resNum/base;
}

struct Rat
{
    char whole[MAXN];
    char finite[MAXN];
    char infinite[MAXN];
    int wholeLen, finiteLen, infiniteLen;
};

void Normalize(Rat& ratNum)
{
    //trailing zeros
    if (ratNum.wholeLen>1)
    {
        int trailingZerosCount=0;
        for (int i=ratNum.wholeLen-1; i>0; i--)
        {
            if (ratNum.whole[i]!='0')
            {
                break;
            }
            trailingZerosCount++;
        }
        ratNum.wholeLen-=trailingZerosCount;
    }
    if (ratNum.infiniteLen==0) return;
    //period in infinite
    for (int potPerLen=1; potPerLen<=ratNum.infiniteLen/2; potPerLen++)
    {
        if (ratNum.infiniteLen % potPerLen != 0) continue;
        bool foundPer=true;
        for (int i=1; i<ratNum.infiniteLen / potPerLen; i++)
        {
            for (int j=0; j<potPerLen; j++)
            {
                if (ratNum.infinite[j+i*potPerLen]!=ratNum.infinite[j])
                {
                    foundPer=false;
                    break;
                }
            }
            if (!foundPer) break;
        }
        if (foundPer)
        {
            ratNum.infiniteLen=potPerLen;
        }
    }
    //part of finite can be in infinite
    int periodTimes=0;
    for (periodTimes=0; periodTimes<ratNum.finiteLen/ratNum.infiniteLen; periodTimes++)
    {
        bool isPeriod=true;
        for (int i=0; i<ratNum.infiniteLen; i++)
        {
            if (ratNum.finite[i+periodTimes*ratNum.infiniteLen]!=ratNum.infinite[i])
            {
                isPeriod=false;
            }
        }
        if (!isPeriod) break;
    }
    ratNum.finiteLen-=periodTimes*ratNum.infiniteLen;
    for (int i=0; i<ratNum.finiteLen; i++)
    {
        ratNum.finite[i]=ratNum.finite[i+periodTimes*ratNum.infiniteLen];
    }
    while (ratNum.finite[0]==ratNum.infinite[0])
    {
        for (int i=0; i<ratNum.infiniteLen-1; i++) ratNum.infinite[i]=ratNum.infinite[i+1];
        ratNum.infinite[ratNum.infiniteLen-1]=ratNum.finite[0];
        ratNum.finiteLen--;
        for (int i=0; i<ratNum.finiteLen; i++) ratNum.finite[i]=ratNum.finite[i+1];
    }
    //limit
    bool limit=true;
    for (int i=0; i<ratNum.infiniteLen; i++)
    {
        if (ratNum.infinite[i]!=digitToSymbolInB(base-1))
        {
            limit=false;
            break;
        }
    }
    if (limit)
    {
        ratNum.infiniteLen=0;
        if (ratNum.finiteLen>0) ratNum.finite[ratNum.finiteLen-1]++;
        else
        {
            if (ratNum.whole[0]!=digitToSymbolInB(base-1))
            {
                if (ratNum.whole[0]=='9') ratNum.whole[0]='A';
                else ratNum.whole[0]++;
            }
            for (int i=0; i<ratNum.wholeLen; i++)
            {
                if (ratNum.whole[i]!=digitToSymbolInB(base-1))
                {
                    if (ratNum.whole[i]=='9') ratNum.whole[i]='A';
                    else ratNum.whole[i]++;
                    break;
                }
                ratNum.whole[i]='0';
            }
            if (ratNum.whole[ratNum.wholeLen-1]=='0')
            {
                ratNum.wholeLen++;
                ratNum.whole[ratNum.wholeLen-1]='1';
            }
        }
    }
}

void PrintRat(Rat ratNum)
{
    for (int i=ratNum.wholeLen-1; i>=0; i--) printf("%c", ratNum.whole[i]);
    if (ratNum.finiteLen==0 && ratNum.infiniteLen==0)
    {
        printf("\n");
        return;
    }
    printf(".");
    for (int i=ratNum.finiteLen-1; i>=0; i--) printf("%c", ratNum.finite[i]);
    if (ratNum.infiniteLen==0)
    {
        printf("\n");
        return;
    }
    printf("(");
    for (int i=ratNum.infiniteLen-1; i>=0; i--) printf("%c", ratNum.infinite[i]);
    printf(")\n");
}

Rat ReadRat()
{
    Rat result;
    result.wholeLen=0;
    result.finiteLen=0;
    result.infiniteLen=0;
    char input[MAXN];
    scanf("%s", &input);
    int currPart=0;
    for (int i=0; i<strlen(input); i++)
    {
        if (input[i]=='.' || input[i]=='(' || input[i]==')')
        {
            if (currPart==0)
            {
                result.wholeLen=i;
                for (int j=0; j<result.wholeLen; j++) result.whole[j]=input[i-1-j];
            }
            else if (currPart==1)
            {
                result.finiteLen=i-result.wholeLen-1;
                for (int j=0; j<result.finiteLen; j++) result.finite[j]=input[i-1-j];
            }
            else if (currPart==2)
            {
                result.infiniteLen=i-result.finiteLen-result.wholeLen-2;
                for (int j=0; j<result.infiniteLen; j++) result.infinite[j]=input[i-1-j];
            }
            currPart++;
            continue;
        }
        if (i==strlen(input)-1)
        {
            if (currPart==0)
            {
                result.wholeLen=i+1;
                for (int j=0; j<result.wholeLen; j++) result.whole[j]=input[i-j];
            }
            else if (currPart==1)
            {
                result.finiteLen=i-result.wholeLen;
                for (int j=0; j<result.finiteLen; j++) result.finite[j]=input[i-j];
            }
        }
    }
    return result;
}

void NOKinfinites(Rat& ratNum1, Rat& ratNum2)
{
    int nok=NOK(ratNum1.infiniteLen, ratNum2.infiniteLen);
    for (int i=1; i<nok/ratNum1.infiniteLen; i++)
    {
        for (int j=0; j<ratNum1.infiniteLen; j++)
        {
            ratNum1.infinite[j+i*ratNum1.infiniteLen]=ratNum1.infinite[j];
        }
    }
    for (int i=1; i<nok/ratNum2.infiniteLen; i++)
    {
        for (int j=0; j<ratNum2.infiniteLen; j++)
        {
            ratNum2.infinite[j+i*ratNum2.infiniteLen]=ratNum2.infinite[j];
        }
    }
    ratNum1.infiniteLen=nok;
    ratNum2.infiniteLen=nok;
}

void RollADigit(Rat& ratNum)
{
    ratNum.finiteLen++;
    for (int i=ratNum.finiteLen-1; i>0; i--) ratNum.finite[i]=ratNum.finite[i-1];
    if (ratNum.infiniteLen==0)
    {
        ratNum.finite[0]='0';
        return;
    }
    ratNum.finite[0]=ratNum.infinite[ratNum.infiniteLen-1];
    for (int i=ratNum.infiniteLen-1; i>0; i--) ratNum.infinite[i]=ratNum.infinite[i-1];
    ratNum.infinite[0]=ratNum.finite[0];
}

Rat SumTwoRats(Rat ratNum1, Rat ratNum2)
{
    if (ratNum1.finiteLen<ratNum2.finiteLen)
    {
        Rat s;
        s=ratNum1;
        ratNum1=ratNum2;
        ratNum2=s;
    }
    Rat result;
    while (ratNum1.finiteLen>ratNum2.finiteLen)
    {
        RollADigit(ratNum2);
    }
    //sum infinite parts
    if (ratNum1.infiniteLen>0 || ratNum2.infiniteLen>0)
    {
        if (ratNum1.infiniteLen==0)
        {
            ratNum1.infiniteLen=1;
            ratNum1.infinite[0]='0';
        }
        if (ratNum2.infiniteLen==0)
        {
            ratNum2.infiniteLen=1;
            ratNum2.infinite[0]='0';
        }
        NOKinfinites(ratNum1, ratNum2);
    }
    result.infiniteLen=ratNum1.infiniteLen;
    int carry=0;
    for (int i=0; i<ratNum1.infiniteLen; i++)
    {
        result.infinite[i]=sumTwoDigits(ratNum1.infinite[i], ratNum2.infinite[i], carry);
        carry=carryFromSum(ratNum1.infinite[i], ratNum2.infinite[i], carry);
    }
    if (carry!=0)
    {
        for (int i=0; i<ratNum1.infiniteLen; i++)
        {
            result.infinite[i]=sumTwoDigits(ratNum1.infinite[i], ratNum2.infinite[i], carry);
            carry=carryFromSum(ratNum1.infinite[i], ratNum2.infinite[i], carry);
        }
    }
    //sum finiteParts
    result.finiteLen=ratNum1.finiteLen;
    for (int i=0; i<result.finiteLen; i++)
    {
        result.finite[i]=sumTwoDigits(ratNum1.finite[i], ratNum2.finite[i], carry);
        carry=carryFromSum(ratNum1.finite[i], ratNum2.finite[i], carry);
    }
    //sum whole parts
    int i;
    for (i=0; i<ratNum1.wholeLen || i<ratNum2.wholeLen || carry>0; i++)
    {
        char first='0';
        if (i < ratNum1.wholeLen) first=ratNum1.whole[i];
        char second='0';
        if (i < ratNum2.wholeLen) second=ratNum2.whole[i];
        result.whole[i]=sumTwoDigits(first, second, carry);
        carry=carryFromSum(first, second, carry);
    }
    result.wholeLen=i;
    return result;
}
int main()
{
    scanf("%d", &base);
    Rat ratNum1=ReadRat(), ratNum2=ReadRat();
    Normalize(ratNum1);
    Normalize(ratNum2);
    Rat resultRat=SumTwoRats(ratNum1, ratNum2);
    Normalize(resultRat);
    PrintRat(resultRat);
}
