#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

const int N=(5e4)+5;
const int M=(2e5)+5;

struct Edge
{
 int from;
 int to;
 int cap;
 bool active;
};

Edge edges[M];
vector <int> g[N],cd,dangerous;
bool oldstate[M],blocked[M];
int used[N];

bool Compare(Edge p,Edge q)
{
 return p.cap<q.cap;
}

int iter;

void DFS(int v)
{
 int i,ind;

 used[v]=iter;

 for(i=0;i<g[v].size();i++)
 {
  ind=g[v][i];

  if(edges[ind].to!=v)
  {
   if(used[edges[ind].to]!=iter && edges[ind].active)
    DFS(edges[ind].to);
  }

  if(edges[ind].from!=v)
  {
   if(used[edges[ind].from]!=iter && edges[ind].active)
    DFS(edges[ind].from);
  }
 }
}

int main()
{

int n,m,k,i,j,low,mid,high,comp,snow,bl,sz;
bool fl;

scanf("%d%d%d",&n,&m,&k);

 for(i=1;i<=m;i++)
  scanf("%d%d%d",&edges[i].from,&edges[i].to,&edges[i].cap);

sort(edges+1,edges+m+1,Compare);

 for(i=1;i<=m;i++)
 {
  g[edges[i].from].push_back(i);
  g[edges[i].to].push_back(i);

  edges[i].active=true;
  oldstate[i]=true;
 }

snow=-1;
iter=0;
   for(i=1;i<=n;i++)
   {
     for(j=0;j<g[i].size();j++)
      edges[g[i][j]].active=false;

    fl=false;
    iter++;
    comp=0;
     for(j=1;j<=n;j++)
     {
       if(j==i)
        continue;

       if(used[j]!=iter)
       {
        comp++;

         if(comp==2)
         {
          fl=true;
          break;
         }

        DFS(j);
       }
     }

     if(fl)
      cd.push_back(i);

     for(j=0;j<g[i].size();j++)
      edges[g[i][j]].active=oldstate[g[i][j]];
   }

   sz=cd.size();
    if(sz>=k)
    {
     snow=1;
     dangerous=cd;
    }

 for(bl=1;bl<=m;bl++)
 {
   if(blocked[bl])
    continue;

  blocked[bl]=true;
  edges[bl].active=false;
  oldstate[bl]=false;
  i=bl+1;
   while(i<=m && edges[i].cap==edges[i-1].cap)
   {
    blocked[i]=true;
    edges[i].active=false;
    oldstate[i]=false;
    i++;
   }

  fl=true;
  comp=0;
  iter++;
   for(i=1;i<=n;i++)
   {
    if(used[i]!=iter)
    {
     comp++;

      if(comp==2)
      {
       fl=false;
       break;
      }

     DFS(i);
    }
   }

   if(!fl)
    break;

  cd.clear();
   for(i=1;i<=n;i++)
   {
     for(j=0;j<g[i].size();j++)
      edges[g[i][j]].active=false;

    fl=false;
    iter++;
    comp=0;
     for(j=1;j<=n;j++)
     {
       if(j==i)
        continue;

       if(used[j]!=iter)
       {
        comp++;

         if(comp==2)
         {
          fl=true;
          break;
         }

        DFS(j);
       }
     }

     if(fl)
      cd.push_back(i);

     for(j=0;j<g[i].size();j++)
      edges[g[i][j]].active=oldstate[g[i][j]];
   }

   sz=cd.size();
    if(sz>=k)
    {
     snow=edges[bl].cap;
     dangerous=cd;
     break;
    }
 }

sz=dangerous.size();

printf("%d %d\n",snow,sz);

 if(snow==-1)
  return 0;

 for(i=0;i<sz;i++)
  printf("%d ",dangerous[i]);

printf("\n");

return 0;
}
