#include "hunter.h"
#include <vector>
#include <iostream>
using namespace std;

bool used[105][105];

void Move(pair <int,int> lastmove,int dir)
{
 pair <int,int> newmove;

   while(1)
   {
    newmove=makeMove(lastmove.first,lastmove.second+dir);

     if(newmove.first==-1 && newmove.second==-1)
      return;

     lastmove=newmove;
   }
}

void MoveRandomly(pair <int,int> lastmove,int n,int m)
{
 pair <int,int> newmove;

  while(1)
  {
   used[lastmove.first][lastmove.second]=true;

    if(lastmove.first+1<n && !used[lastmove.first+1][lastmove.first+1])
    {
     newmove=makeMove(lastmove.first+1,lastmove.second);
     used[lastmove.first+1][lastmove.second]=true;

      if(newmove.first==-1 && newmove.second==-1)
       return;

     lastmove=newmove;
     continue;
    }

    if(lastmove.first-1>=0 && !used[lastmove.first-1][lastmove.second])
    {
     newmove=makeMove(lastmove.first-1,lastmove.second);
     used[lastmove.first-1][lastmove.second]=true;

      if(newmove.first==-1 && newmove.second==-1)
       return;

     lastmove=newmove;
     continue;
    }

    if(lastmove.second+1<m && !used[lastmove.first][lastmove.second+1])
    {
     newmove=makeMove(lastmove.first,lastmove.second+1);
     used[lastmove.first][lastmove.second+1]=true;

      if(newmove.first==-1 && newmove.second==-1)
       return;

     lastmove=newmove;
     continue;
    }

    if(lastmove.second-1>0 && !used[lastmove.first][lastmove.second-1])
    {
      newmove=makeMove(lastmove.first,lastmove.second-1);
      used[lastmove.first][lastmove.second-1]=true;

      if(newmove.first==-1 && newmove.second==-1)
       return;

     lastmove=newmove;
     continue;
    }
  }
}

void play(int n, int m, const vector<vector<char> > &table)
{
 int i,lasttrap,gap,rightmost;
 pair <int,int> lastmove;

  if(n==1)
  {
   lasttrap=-1;
    for(i=0;i<m;i++)
    {
     if(table[0][i]=='#')
     {
      gap=i-lasttrap-1;

       if(gap%2==1)
       {
        lastmove.first=0;
        lastmove.second=lasttrap;
        Move(lastmove,1);
        return;
       }

      lasttrap=i;
     }
    }

    gap=m-lasttrap-1;
     if(gap%2==1)
     {
      lastmove.first=0;
      lastmove.second=lasttrap;
      Move(lastmove,1);
      return;
      }

    lastmove=makeMove(-1,-1);

     if(lastmove.first==-1 && lastmove.second==-1)
      return;

    rightmost=-1;
     for(i=lastmove.second-1;i>=0;i--)
     {
      if(table[0][i]=='#')
      {
       rightmost=i;
       break;
      }
     }

    gap=lastmove.second-rightmost-1;

     if(gap%2==1)
     {
      used[0][0]=true;
      Move(lastmove,-1);
      return;
     }
     else
     {
      Move(lastmove,1);
      return;
     }
  }

  if((n*m)%2==1)
  {
   lastmove=makeMove(0,0);
   MoveRandomly(lastmove,n,m);
   return;
  }
  else
  {
   lastmove=makeMove(-1,-1);
   MoveRandomly(lastmove,n,m);
   return;
  }
}
