#include "hunter.h"

#include<map>
#include<time.h>
#include<random>

using namespace std;

const int MAXN = 105;
const long long mod1 = 1e9 + 7, mod2 = 1e9 + 9;

int N, M;
int operations = 0;

struct state
{
    int x, y;
    long long h1, h2;
};

bool operator <(const state A, const state B)
{
    if(A.h1!=B.h1) return A.h1<B.h1;
    if(A.h2!=B.h2) return A.h2<B.h2;
    if(A.x!=B.x) return A.x<B.x;
    return A.y<B.y;
}

char a[MAXN][MAXN];
map <state, bool> memo;

state makeState(int x, int y)
{
    state add;

    add.x = x;
    add.y = y;

    add.h1 = 0;
    add.h2 = 0;
    for(int i = 0;i<N;i++)
    {
        for(int j = 0;j<M;j++)
        {
            if(a[i][j]=='.')
            {
                add.h1 = (add.h1*3 + 1)%mod1;
                add.h2 = (add.h2*5 + 1)%mod2;
            }
            else
            {
                add.h1 = (add.h1*3 + 2)%mod1;
                add.h2 = (add.h2*5 + 2)%mod2;
            }
        }
    }

    return add;
}

bool calcState(int x, int y)
{
    operations++;
    if(operations>1e4) return false;

    bool result = false;
    if(N*M>100 && rand()%100<30)
    {
        state add = makeState(x, y);
        memo[add] = false;

        return false;
    }

    if(x-1>=0 && result==false && a[x-1][y]=='.')
    {
        a[x-1][y] = '#';
        result |= calcState(x-1, y);
        a[x-1][y] = '.';
    }
    if(x+1<N && result==false && a[x+1][y]=='.')
    {
        a[x+1][y] = '#';
        result |= calcState(x+1, y);
        a[x+1][y] = '.';
    }

    if(y-1>=0 && result==false && a[x][y-1]=='.')
    {
        a[x][y-1] = '#';
        result |= calcState(x, y-1);
        a[x][y-1] = '.';
    }
    if(y+1<M && result==false && a[x][y+1]=='.')
    {
        a[x][y+1] = '#';
        result |= calcState(x, y+1);
        a[x][y+1] = '.';
    }

    state add = makeState(x, y);
    memo[add] = result^true;

    //cout << x << " ** " << y << " " << (result^true)  << '\n';
    return result^true;
}

void play(int n, int m, const vector < vector <char> > &table)
{
    N = n;
    M = m;
    int x, y;

    int posI = -1, posJ = -1;
    pair <int, int> newPos;
    bool result = false, newResult;

    state current;

    for(int i = 0;i<n;i++)
    {
        for(int j = 0;j<m;j++)
            a[i][j] = table[i][j];
    }

    for(int i = 0;i<n;i++)
    {
        for(int j = 0;j<m;j++)
        {
            if(a[i][j]=='.')
            {
                operations = 0;

                a[i][j] = '#';
                current = makeState(i, j);

                result = calcState(i, j);
                a[i][j] = '.';

                //cout << " ------ " << " " << result << '\n';

                if(memo[current]==true)
                {
                    posI = i;
                    posJ = j;
                    a[i][j] = '#';

                    break;
                }
            }
        }
        if(posI!=-1) break;
    }

    //cout << posI << " -- " << posJ << '\n';

    newPos = makeMove(posI, posJ);
    posI = newPos.first;posJ = newPos.second;

    a[posI][posJ] = '#';
    while(true)
    {
        x = posI;
        y = posJ;
        result = false;
        newResult = false;

        posI = -1;posJ = -1;
        if(x-1>=0 && result==false && a[x-1][y]=='.')
        {
            operations = 0;

            a[x-1][y] = '#';
            newResult |= calcState(x-1, y);
            a[x-1][y] = '.';

            if(result==false)
            {
                posI = x - 1;
                posJ = y;
            }
            result |= newResult;
        }
        if(x+1<n && result==false && a[x+1][y]=='.')
        {
            operations = 0;

            a[x+1][y] = '#';
            newResult |= calcState(x+1, y);
            a[x+1][y] = '.';

            if(result==false)
            {
                posI = x + 1;
                posJ = y;
            }
            result |= newResult;
        }

        if(y-1>=0 && result==false && a[x][y-1]=='.')
        {
            operations = 0;

            a[x][y-1] = '#';
            newResult |= calcState(x, y-1);
            a[x][y-1] = '.';

            if(result==false)
            {
                posI = x;
                posJ = y - 1;
            }
            result |= newResult;
        }
        if(y+1<m && result==false && a[x][y+1]=='.')
        {
            operations = 0;

            a[x][y+1] = '#';
            newResult |= calcState(x, y+1)^true;
            a[x][y+1] = '.';

            if(result==false)
            {
                posI = x;
                posJ = y + 1;
            }
            result |= newResult;
        }

        if(posI==-1) break;
        a[posI][posJ] = '#';

        newPos = makeMove(posI, posJ);
        posI = newPos.first;posJ = newPos.second;

        a[posI][posJ] = '#';
    }
}
