#include<iostream>
#include<algorithm>

using namespace std;

const int MAXN = 50005, MAXM = 2*1e5 + 5;

struct edge
{
    int u, v;
    int value;
};


bool operator <(const edge A, const edge B)
{
    if(A.value!=B.value) return A.value<B.value;
    if(A.u!=B.u) return A.u<B.u;
}

int n, m, k;
edge a[MAXM];

int l, r, mid;
int parent[MAXN], treeSize[MAXN];

vector <int> nodes;

int Find(int x)
{
    if(parent[x]==x) return x;

    parent[x] = Find(parent[x]);
    return parent[x];
}

void Union(int u, int v)
{
    if(treeSize[u]<treeSize[v])
    {
        parent[u] = parent[v];
        treeSize[v] += treeSize[u];
    }
    else
    {
        parent[v] = parent[u];
        treeSize[u] += treeSize[v];
    }
}

int check(int index)
{
    int value;
    nodes.clear();

    if(index==-1) value = 0;
    else value = a[index].value;

    int u, v;
    int answer = 0;

    int firstParent;

    for(int i = 1;i<=n;i++)
    {
        parent[i] = i;
        treeSize[i] = 1;
    }

    for(int i = index+1;i<m;i++)
    {
        if(a[i].value<=value) continue;

        u = Find(a[i].u);
        v = Find(a[i].v);
        if(u!=v)
        {
            Union(u, v);
        }
    }

    firstParent = Find(1);
    for(int i = 2;i<=n;i++)
    {
        if(Find(i)!=firstParent)
        {
            return -1;
        }
    }


    for(int i = 1;i<=n;i++)
    {
        for(int j = 1;j<=n;j++)
        {
            parent[j] = j;
            treeSize[j] = 1;
        }

        for(int j = index+1;j<m;j++)
        {
            if(a[j].value<=value)
            {
                continue;
            }
            if(a[j].u==i || a[j].v==i) continue;

            u = Find(a[j].u);
            v = Find(a[j].v);
            if(u!=v)
            {
                Union(u, v);
            }
        }

        if(i!=1)
            firstParent = Find(1);
        else
            firstParent = Find(2);

        for(int j = 1;j<=n;j++)
        {
            if(j==i) continue;
            if(Find(j)!=firstParent)
            {
                //cout << i << " --> " << firstParent << " " << parent[j] << " || " << j << '\n';

                answer++;
                nodes.push_back(i);

                break;
            }
        }
    }

    return answer;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int result = 0;

    cin >> n >> m >> k;
    for(int i = 0;i<m;i++)
    {
        cin >> a[i].u >> a[i].v >> a[i].value;
    }
    sort(a, a+m);

    if(check(-1)>=k)
    {
        cout << "0 " << nodes.size() << '\n';

        cout << nodes[0];
        for(int i = 1;i<nodes.size();i++)
            cout << " " << nodes[i];
        cout << '\n';

        return 0;
    }

    l = 0;
    r = m - 1;
    while(l+1<r)
    {
        mid = (l+r)/2;

        result = check(mid);
        if(result==-1) r = mid - 1;
        else
        {
            if(result>=k) r = mid - 1;
            else l = mid + 1;
        }
    }

    if(check(l)>=k)
    {
        cout << a[l].value << " " << nodes.size() << '\n';

        cout << nodes[0];
        for(int i = 1;i<nodes.size();i++)
            cout << " " << nodes[i];
        cout << '\n';
    }
    else if(check(r)>=k)
    {
        cout << a[r].value << " " << nodes.size() << '\n';

        cout << nodes[0];
        for(int i = 1;i<nodes.size();i++)
            cout << " " << nodes[i];
        cout << '\n';
    }
    else cout << "-1 0" << '\n';
}

/*
8 13 3
1 2 19
1 3 13
2 3 5
4 2 9
2 5 7
3 5 17
6 3 8
3 8 12
4 7 11
5 7 5
7 2 10
7 6 13
8 5 16
*/
