#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cstdint>
#include <queue>

using namespace std;

uint32_t k;

struct edge
{
    uint32_t b, s;
};

vector < vector < edge > > ss;
set <uint32_t> sn;

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    uint32_t n, m;
    cin>>n>>m>>k;
    ss.resize(n);
    for(uint32_t i=0; i<m; i++)
    {   uint32_t a, b, s;
        cin>>a>>b>>s;
        if(a==b)continue;
        a--; b--;
        sn.insert(s);
        ss[a].push_back({b, s});
        ss[b].push_back({a, s});
    }
    //for(auto x: sn)
    //    cout<<x<<' ';
    //cout<<endl;
}

void can_go (uint32_t from, uint32_t sn, vector<bool> &can, uint32_t dont_use)
{
    can.resize(ss.size());
    queue<uint32_t> q;
    q.push(from);
    can[from]=true;
    while(!q.empty())
    {
        uint32_t cur=q.front();
        q.pop();
        if(cur==dont_use)continue;
        for(uint32_t i=0; i<ss[cur].size(); i++)
        {
            if(sn>=ss[cur][i].s)continue;
            if(ss[cur][i].b==dont_use)continue;
            if(can[ss[cur][i].b])continue;
            q.push(ss[cur][i].b);
            can[ss[cur][i].b]=true;
        }
    }
}

bool is_danger (uint32_t x, uint32_t sn)
{
    for(uint32_t i=0; i<ss.size(); i++)
    {   if(i==x)continue;
        vector<bool> can1, can2;
        can_go(i, sn, can1, -1);
        can_go(i, sn, can2, x);
        can1[x]=false;
        /*
        cout<<"----------------------\n";
        cout<<i<<endl;
        for(auto x: can1)
            cout<<x<<' ';
        cout<<endl;
        for(auto x: can2)
            cout<<x<<' ';
        cout<<endl;
        cout<<"----------------------\n";
        */
        if(can1!=can2)return true;
    }
    return false;
}

void calc_all_danger(uint32_t sn, vector<uint32_t> &danger)
{
    danger.reserve(ss.size());
    for(uint32_t i=0; i<ss.size(); i++)
    {
        if(is_danger(i, sn))danger.push_back(i);
    }
}

void solve()
{
    vector<uint32_t> danger;
    for(auto it=sn.begin(); it!=sn.end(); it++)
    {
        calc_all_danger(*(it), danger);
        if(danger.size()>=k)
        {
            cout<<(*(it))<<' '<<danger.size()<<'\n';
            for(uint32_t i=0; i<danger.size(); i++)
                cout<<danger[i]+1<<' ';
            cout<<'\n';
            exit(0);
        }
        danger.clear();
    }
    cout<<"-1 0\n";
}

int main()
{
    init();
    solve();
    /*
    vector<bool> can;
    can_go(4, 8, can, 0);
    for(uint32_t i=0; i<can.size(); i++)
        cout<<can[i]<<' ';
    */
    /*
    vector<uint32_t> danger;
    calc_all_danger(8, danger);
    for(auto x:danger)
        cout<<x<<' ';
    */
    //cout<<is_danger(0, 8)<<' ';
}
