#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include "hunter.h"
#define pb push_back
#define mp make_pair
using namespace std;
const int MAXN=1e2+5;

int N,M;
char tab[MAXN][MAXN];

bool legal(int r,int c)
{
    if(r < 0 || r > N)
        return false;
    if(c < 0 || c > M)
        return false;

    if(tab[r][c] == '.')
        return true;
    return false;
}

void corner_case_1row()
{
   int i;
   int pred[MAXN],after[MAXN];
   int cnt=0;

   for(i=0;i<M;i++)
   {
      pred[i]=cnt;

      if(tab[0][i] == '.')
        cnt++;
      else
        cnt=0;
   }

   cnt=0;
   for(i=M-1;i>=0;i--)
   {
       after[i]=cnt;
       if(tab[0][i] == '.')
        cnt++;
       else
        cnt=0;
   }

   int rem=-1;
   for(i=0;i<M;i++)
   {
       if(tab[0][i] == '#')
        continue;
       if(pred[i]%2 == 0 && after[i]%2 == 0)
        rem=i;
   }

   pair <int,int> at;
   if(rem != -1)
   {
       at = makeMove(0,rem);
       if(at.second > rem)
       {
        while(at.second != -1)
         at=makeMove(0,at.second+1);
       }
       else
       {

         while(at.second != -1)
           at=makeMove(0,at.second-1);
       }

       return;
   }

   at = makeMove(-1,-1);
   if(at.second == -1)
    return;

   if(pred[at.second]%2 == 1)
   {
      while(at.second != -1)
       at=makeMove(0,at.second-1);
   }
   else
   {
       while(at.second != -1)
        at=makeMove(0,at.second+1);
   }
}

pair <int,int> dir[4];

int get_dir(pair <int,int> prev,pair <int,int> now)
{
    if(now.second > prev.second)
        return 0;
    if(now.first > prev.first)
        return 1;
    if(now.second < prev.second)
        return 2;
    if(now.first < prev.first)
        return 3;
}

pair <int,int> Move(pair <int,int> t)
{
    tab[t.first][t.second]='#';
    return makeMove(t.first,t.second);
}

void play(int n,int m,const vector<vector<char> > &table)
{
    int i,j;

    N=n;
    M=m;

    for(i=0;i<n;i++)
    {
        for(j=0;j<m;j++)
        {
            tab[i][j]=table[i][j];
        }
    }

    if(n == 1)
    {
        corner_case_1row();
        return;
    }

    dir[0]=mp(0,1);
    dir[1]=mp(1,0);
    dir[2]=mp(0,-1);
    dir[3]=mp(-1,0);

  /*  for(i=0;i<n;i++)
    {
        for(j=0;j<m;j++)
        {
            if(tab[i][j] == '#')
                continue;

            if(!legal(i-1,j) && !legal(i+1,j) && !legal(i,j-1) && !legal(i,j+1))
            {
                makeMove(i,j);
                return;
            }
        }
    }*/

    if(n%2==0 && m%2 ==0)
      while(1)
         n++;
    pair <int,int> prev,at;
    prev=mp(0,0);
    at=Move(prev);
    while(at.first != -1)
    {
        int ind=get_dir(prev,at);
        if(legal(at.first+dir[ind].first,at.second+dir[ind].second))
        {
            prev=mp(at.first+dir[ind].first,at.second+dir[ind].second);
            at=Move(prev);

            continue;
        }

        for(i=0;i<4;i++)
        {
            if(legal(at.first+dir[i].first,at.second+dir[i].second))
            {
                prev=mp(at.first+dir[i].first,at.second+dir[i].second);
                at=Move(prev);

                break;
            }
        }
    }


}

/*

1 6
...#.#

*/

