#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include "hunter.h"
#define pb push_back
#define mp make_pair
using namespace std;
const int MAXN=1e2+5;

int N,M;
char tab[MAXN][MAXN];
bool vis[MAXN][MAXN];

bool legal(int r,int c)
{
    if(r < 0 || r >= N)
        return false;
    if(c < 0 || c >= M)
        return false;

    if(tab[r][c] == '#' || vis[r][c])
        return false;
    return true;
}

void corner_case_1row()
{
   int i;
   int pred[MAXN],after[MAXN];
   int cnt=0;

   for(i=0;i<M;i++)
   {
      pred[i]=cnt;

      if(tab[0][i] == '.')
        cnt++;
      else
        cnt=0;
   }

   cnt=0;
   for(i=M-1;i>=0;i--)
   {
       after[i]=cnt;
       if(tab[0][i] == '.')
        cnt++;
       else
        cnt=0;
   }

   int rem=-1;
   for(i=0;i<M;i++)
   {
       if(tab[0][i] == '#')
        continue;
       if(pred[i]%2 == 0 && after[i]%2 == 0)
        rem=i;
   }

   pair <int,int> at;
   if(rem != -1)
   {
       at = makeMove(0,rem);
       if(at.second > rem)
       {
        while(at.second != -1)
         at=makeMove(0,at.second+1);
       }
       else
       {

         while(at.second != -1)
           at=makeMove(0,at.second-1);
       }

       return;
   }

   at = makeMove(-1,-1);
   if(at.second == -1)
    return;

   if(pred[at.second]%2 == 1)
   {
      while(at.second != -1)
       at=makeMove(0,at.second-1);
   }
   else
   {
       while(at.second != -1)
        at=makeMove(0,at.second+1);
   }
}

pair <int,int> dir[4];

int get_dir(pair <int,int> prev,pair <int,int> now)
{
    if(now.second > prev.second)
        return 0;
    if(now.first > prev.first)
        return 1;
    if(now.second < prev.second)
        return 2;
    if(now.first < prev.first)
        return 3;
}


int solve(int r,int c)
{
   vis[r][c]=true;

   int res=0;
   for(int i=0;i<4;i++)
   {
       if(legal(r+dir[i].first,c+dir[i].second))
       {
          res|=(1 ^ (solve(r+dir[i].first,c+dir[i].second)));
       }
   }

   vis[r][c]=false;
   return res;
}

pair <int,int> from[MAXN][MAXN];
int get_from(int r,int c)
{
   vis[r][c]=true;

   int res=0;
   for(int i=0;i<4;i++)
   {
       if(legal(r+dir[i].first,c+dir[i].second))
       {
          res|=(1 ^ (get_from(r+dir[i].first,c+dir[i].second)));
          from[r][c]=mp(r+dir[i].first,c+dir[i].second);
       }
   }

   vis[r][c]=false;
   return res;
}


void play(int n,int m,const vector<vector<char> > &table)
{
    int i,j;

    N=n;
    M=m;

    for(i=0;i<n;i++)
    {
        for(j=0;j<m;j++)
        {
            tab[i][j]=table[i][j];
        }
    }

    if(n == 1)
    {
        corner_case_1row();
        return;
    }

    dir[0]=mp(0,1);
    dir[1]=mp(1,0);
    dir[2]=mp(0,-1);
    dir[3]=mp(-1,0);

    int remi,remj;
    for(i=0;i<n;i++)
    {
        for(j=0;j<m;j++)
        {
            memset(vis,false,sizeof(vis));
            if(!solve(i,j))
            {
                remi=i;
                remj=j;

                break;
            }
        }
    }

    memset(vis,false,sizeof(vis));
    get_from(remi,remj);

    pair <int,int> at;
    at=makeMove(remi,remj);
    while(at.first != -1)
    {
        at=makeMove(from[at.first][at.second].first,from[at.first][at.second].second);
    }



}

/*

1 6
...#.#

*/

