#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#define pb push_back
#define mp make_pair
using namespace std;
const int N=5e4+5;
const int M=2e5+5;

int n,m,k;
struct edge{

  int u,v;
  int s;

  bool operator <(edge other) const
  {
      return s < other.s;
  }

}e[M];

int disc[N],low_reach[N];
bool is_artic[N];
vector <int> nb[N];

bool vis[N];

void relax()
{
    memset(disc,0,sizeof(disc));
    memset(low_reach,0,sizeof(low_reach));
    memset(vis,false,sizeof(vis));
    memset(is_artic,false,sizeof(is_artic));

    for(int i=1;i<=n;i++)
        nb[i].clear();
}

int visited;
void DFS_simple(int v)
{
    vis[v]=true;
    visited++;

    for(int i=0;i<nb[v].size();i++)
    {
        if(!vis[nb[v][i]])
            DFS_simple(nb[v][i]);
    }
}

int timer;
void DFS(int v,int parent)
{
    vis[v]=true;
    low_reach[v]=disc[v]=++timer;
    int type2=disc[v];
    int highest=0;

    int children=0;
    for(int i=0;i<nb[v].size();i++)
    {
        if(!vis[nb[v][i]])
        {
            DFS(nb[v][i],v);
            low_reach[v]=min(low_reach[v],low_reach[nb[v][i]]);
            highest=max(highest,low_reach[nb[v][i]]);

            children++;
        }
        else
        {
            if(nb[v][i] != parent)
                low_reach[v]=min(low_reach[v],disc[nb[v][i]]);
        }
    }

    if(parent == -1 && children >= 2)
        is_artic[v]=true;
    if(parent != -1 && highest >= disc[v] && children)
        is_artic[v]=true;
}

int check(int mid)
{
    relax();

    int i;

    for(i=m;i>=1;i--)
    {
        if(e[i].s <= mid)
            break;

        nb[e[i].u].pb(e[i].v);
        nb[e[i].v].pb(e[i].u);
    }

    visited=0;
    DFS_simple(1);

    if(visited < n)
        return 1;

    memset(vis,false,sizeof(vis));

    timer=0;
    DFS(1,-1);

    int cnt=0;
    for(i=1;i<=n;i++)
    {
        if(is_artic[i])
            cnt++;
    }

    if(cnt >= k)
        return 0;
    else
        return -1;
}

vector <int> ans;

int main()
{
   int i;

   scanf("%d%d%d", &n, &m, &k);
   for(i=1;i<=m;i++)
   {
       scanf("%d%d%d", &e[i].u, &e[i].v, &e[i].s);
   }

   sort(e+1,e+m+1);

   int low,high,mid;
   int rem=-1;

   low=0;
   high=1000001;
   while(low <= high)
   {
       mid=(low+high)/2;

       int t=check(mid);
       if(t == 0) /// using edges with cost up to mid;
       {
           rem=mid;
           high=mid-1;
       }
       if(t == -1)
       {
           low=mid+1;
       }
       if(t == 1)
       {
           high=mid-1;
       }
   }

   if(rem == -1)
   {
       printf("-1 0\n");
       return 0;
   }

   check(rem);
   for(i=1;i<=n;i++)
   {
       if(is_artic[i])
        ans.pb(i);
   }

   printf("%d %d\n",rem ,(int)ans.size());
   for(i=0;i<ans.size();i++)
   {
       printf("%d", ans[i]);

       if(i < ans.size()-1)
        printf(" ");
   }
   printf("\n");

   return 0;
}


/**

8 13 3
1 2 19
1 3 13
2 3 5
4 2 9
2 5 7
3 5 17
6 3 8
3 8 12
4 7 11
5 7 5
7 2 10
7 6 13
8 5 16

**/

/**

3 3 1
1 2 42
2 3 42
1 3 666

**/

/**

4 4 1
1 2 2
2 3 4
3 4 3
4 1 1

**/
