#include<iostream>
#include<vector>
#include<set>
#include<algorithm>

using namespace std;

int n,m,k;
vector< vector< pair<int,int> > > a;

set<int> heights;
set<int> dangerous;

int ignoredNode = -1;
bool used[50000];


struct less_height : public binary_function<pair<int,int>, pair<int,int> , bool> {
	bool operator()(pair<int,int> x, pair<int,int> y) { return x.second < y.second; }
};

void dfs(int i){
    used[i] = true;

    for(int j = 0; j < a[i].size(); j++){
        int v = a[i][j].first;
        if(v == ignoredNode)continue;
        if(!used[v]){
            dfs(v);
        }
    }
}

void checkForDanger(){ //very slow
    for(int i = 1; i <= n; i++){
        //cout<<"Checking "<<i<<" for danger"<<endl;
        ignoredNode = i;

        for(int t = 0; t <= n; t++)used[t] = false;

        if(i!=1)
            dfs(1);
        else
            dfs(2);

        for(int t = 1; t <= n; t++){
            if(t != ignoredNode && used[t] == false){
                //cout<<i <<" is dangerous! (Can't reach " << t <<")"<<endl;
                dangerous.insert(i);
                break;
            }
        }
    }
}

void snow(){
    for(int h : heights){
        //cout<<"--Snow is "<<h<< " cm--"<<endl;
        for(int i = 1; i <= n; i++){
            int j = 0;
            if(a[i].size() > 0){
                for(j = 0; j < a[i].size(); j++){
                    if(a[i][j].second > h){
                        break;
                    }
                    //cout<<"Blocked road from " << i << " to " << a[i][j].first<<endl;
                }
                //j--;
                //cout<<j<<endl;

                a[i].erase(a[i].begin(),a[i].begin() + j);

                /*cout<<i<<":"<<endl;
                for(j = 0; j < a[i].size(); j++){
                    cout<<a[i][j].first << " " << a[i][j].second<<endl;
                }*/

            }
        }
        checkForDanger();

        if(dangerous.size() >= k){
            cout<<h<<" "<<dangerous.size()<<endl;

            bool isFirst = true;
            for(int d : dangerous){
                if(!isFirst)cout<<" ";
                cout<<d;
                isFirst = false;
            }
            return;
        }

        //int temp;
        //cin>>temp;
    }
    cout<<"-1 0"<<endl;

}
int main(){
    cin>>n>>m>>k;
    for(int i = 0; i <= n; i++){
        a.push_back(vector< pair<int,int> >());
    }
    for(int i = 0; i < m; i++){
        int x,y,s;
        cin>>x>>y>>s;
        a[x].push_back(pair<int,int> (y,s));
        a[y].push_back(pair<int,int> (x,s));
        heights.insert(s);
    }

    for(int i = 1; i <= n; i++){
        sort(a[i].begin(),a[i].end(),less_height());
    }

    /*for(int i = 0; i < a[1].size(); i++){
        cout<<a[1][i].first << " " << a[1][i].second<<endl;
    }*/


    snow();
    return 0;
}
/*
6 5 5
1 2 5
1 3 4
1 4 8
1 5 7
1 6 1

*/
