#include<iostream>
#include<stdio.h>
#include<vector>
#include<algorithm>
using namespace std ;

#define MAXN 200007
#define LOG 20


int n , m , k ;
struct tuhla {
	int x , y ;
	int len ;
};

int LCA[ MAXN ][ LOG ] ;
int lvl[ MAXN ] ;
int val[ MAXN ] ;
int add[ MAXN ] ;

tuhla a[ MAXN ] ;
vector < int > v[ MAXN ] ;

bool cmp ( tuhla p1 , tuhla p2 ) {
	return ( p1.len < p2.len ) ;
}

int prv[ MAXN ] ;
bool marked[ MAXN ] ;

vector < int > aux ;

int find ( int x ) {
	if ( prv[ x ] == -1 ) { return x ; }
	int y = find ( prv[ x ] ) ;
	prv[ x ] = y ;
	return y ;
}
int COMPS ;
int fstid ;

void UNITE ( tuhla u , int id ) {
	int k1 = find ( u.x ) ;
	int k2 = find ( u.y ) ;
	if ( k1 != k2 ) {
		marked[ id ] = true ;
		v[ u.x ].push_back ( u.y ) ;
		v[ u.y ].push_back ( u.x ) ;
		prv[ k1 ] = k2 ;
		COMPS -- ;
	}
}

void init ( int vertex , int prv ) {
	int i ;
	int sz = v[ vertex ].size ( ) ;
	if ( prv != -1 ) {
		for ( i = 1 ; i < LOG ; i++ ) {
			LCA[ vertex ][ i ] = LCA[ LCA[ vertex ][ i - 1 ] ][ i - 1 ] ;
		}
	}
	for ( i = 0 ; i < sz ; i ++ ) {
		if ( v[ vertex ][ i ] == prv ) { continue ; }
		lvl[ v[ vertex ][ i ] ] = lvl[ vertex ] + 1 ;
		LCA[ v[ vertex ][ i ] ][ 0 ] = vertex ;
		init ( v[ vertex ][ i ] , vertex ) ;
	}
}

int get_LCA ( int x , int y ) {
	int i ;
	for ( i = LOG - 1 ; i >= 0 ; i -- ) {
		if ( lvl[ x ] - (1<<i) >= lvl[ y ] ) {
			x = LCA[ x ][ i ] ;
		}
		if ( lvl[ y ] - (1<<i) >= lvl[ x ] ) {
			y = LCA[ y ][ i ] ;
		}
	}
	for ( i = LOG - 1 ; i >= 0 ; i -- ) {
		if ( LCA[ x ][ i ] != LCA[ y ][ i ] ) {
			x = LCA[ x ][ i ] ;
			y = LCA[ y ][ i ] ;
		}
	}
	if ( x != y ) { x = LCA[ x ][ 0 ] ; }
	return x ;
}

int get ( int x , int val ) {
	int i ;
	for ( i = LOG - 1 ; i >= 0 ; i -- ) {
		if ( val >= (1<<i) ) {
			val -= (1<<i) ;
			x = LCA[ x ][ i ] ;
		}
	}
	return x ;
}


int dfs ( int vertex , int prv ) {
	int i ;
	int sz = v[ vertex ].size ( ) ;
	int cur = 0 ;
	int br = 0 ;
	bool fl = false ;
	for ( i = 0 ; i < sz ; i ++ ) {
		if ( v[ vertex ][ i ] == prv ) { continue ; }
		int ret = dfs ( v[ vertex ][ i ] , vertex ) ;
		cur += ret ;
	}
	cur += add[ vertex ] ;
	if ( cur == 0 ) { val[ LCA[ vertex ][ 0 ] ] = 0 ; }
	return cur ;
}

bool f ( int id ) {
	int i ;
	aux.clear ( ) ;
	for ( i = 0 ; i <= n ; i ++ ) {
		add[ i ] = 0 ;
		val[ i ] = 1 ;
	}
	for ( i = 1 ; i <= m ; i ++ ) {
		if ( a[ i ].len <= a[ id ].len ) { continue ; }
		if ( marked[ i ] == true ) { continue ; }
		int u = get_LCA ( a[ i ].x , a[ i ].y ) ;
		int p1 , p2 ;
		p1 = get ( a[ i ].x , lvl[ a[ i ].x ] - lvl[ u ] - 1 ) ;
		p2 = get ( a[ i ].y , lvl[ a[ i ].y ] - lvl[ u ] - 1 ) ;
		if ( u != a[ i ].x && u != a[ i ].y ) { 
			add[ a[ i ].x ] ++ ;
			add[ a[ i ].y ] ++ ;
			if ( u != 1 ) { 
				add[ u ] -- ;
				add[ u ] -- ;
			}
		}
		else if ( u == a[ i ].x ) {
			if ( u != 1 ) { 
				add[ p2 ] -- ;
			}		
			add[ a[ i ].y ] ++ ;
		}
		else {
			if ( u != 1 ) { 
				add[ p1 ] -- ;
			}
			add[ a[ i ].x ] ++ ;		
		}
	}
	dfs ( 1 , -1 ) ;
	int sz = 0 ;
	for ( i = 1 ; i <= n ; i ++ ) {
		if ( val[ i ] == 0 ) {
			aux.push_back ( i ) ;
			sz ++ ;
		}
	}
	return ( sz >= k ) ;
}


void input ( ) {
	scanf ( "%d%d%d" , &n , &m , &k ) ;
	int i ;
	for ( i = 1 ; i <= m ; i ++ ) {
		scanf ( "%d%d%d" , &a[ i ].x , &a[ i ].y , &a[ i ].len ) ;
	}
	sort ( a + 1 , a + m + 1 , cmp ) ;
}

void solve ( ) {
	int i ;
	for ( i = 1 ; i <= n ; i ++ ) {
		prv[ i ] = -1 ;
	}
	COMPS = n ;
	fstid = m + 1 ;
	for ( i = m ; i >= 1 ; i -- ) {
		UNITE ( a[ i ] , i ) ;
		if ( COMPS == 1 ) {
			fstid = i ;
			break ;
		}
	}
	if ( COMPS > 1 ) {
		printf ( "-1 0\n" ) ;
		return ;
	}
	init ( 1 , -1 ) ;
	int l , r , mid ;
	l = 0 ;
	r = fstid ;
	while ( a[ r ].len == a[ fstid ].len ) { r -- ; }
	while ( r - l > 3 ) {
		mid = ( l + r ) / 2 ;
		if ( f ( mid ) == true ) { r = mid ; }
		else { l = mid ; }
	}
	while ( l <= r && f ( l ) == false ) { l ++ ; }
	int sz = aux.size ( ) ;
	sort ( aux.begin ( ) , aux.end ( ) ) ;
	if ( sz < k ) { printf ( "-1 0\n" ) ; return ; }
	printf ( "%d %d\n" , a[ l ].len , sz ) ;
	for ( i = 0 ; i < sz ; i ++ ) {
		printf ( "%d" , aux[ i ] ) ;
		if ( i == ( sz - 1 ) ) { printf ( "\n" ) ; }
		else { printf ( " " ) ; }
	}
}

int main ( ) {
	input ( ) ;
	solve ( ) ;
	return 0 ;
}
